C    This is the main Fortran module for EPA-CMB8.2;           -TCoulter
C    fRun is called by CMB82.c & directs subsequent calls to routines 
C    below in that sequence:

C***********************************************************************
C     fRun is called by CMB82.c
C     Defines cases and assigns integer values consistent with those defined in CMB82.c
C     Selects 7 cases; depending on the value for CMB82.c's SEL; these cases, in this sequence:
C     DO_SetBatchFlag	(triggers from CMBIntermal's prodecure SetBatchFlag which calls DO_setBatchFlag 
C       in CMB82.c, which passes the flag on to here.
C     DO_CMB
C     DO_SendFracEst
C     DO_SendInfo
C     DO_PData
C     DO_SScont
C     DO_mPIN

      integer*4 function fRun( !AS OF 10/26/04 - 39 arguments!
     &    nSPtot1, nSPfit1, SPcode, SPcode_user,
     &    nPRtot1, nPRfit1, PRcode, PRcode_user,
     &    numCMBfit1, nPROtot1, PROcode,
     &    nambtot1, ADcode,
     &    ambSP, uambSP,
     &    Atotal, uAtotal, sngval,
     &    iSPfit, jPRfit, inestim,
     &    dimiWork, iWork,
     &    dimwork, work,
     &    sel, action, action1,
     &    outbuf, dimoutbuf, lenoutbuf,
     &    cWork,
     &    errbuf, dimerrbuf, lenerrbuf,
     &    Sfitbas, uSfitbas, srcFitFlag, DichotFlag ) !DichotFlag added 10/26/04
C
      integer*4 nSPtot1, nSPfit1, nPRtot1, nPRfit1, numCMBfit1
      integer*4 nambtot1, nPROtot1, DichotFlag        ! Added 10/26/04
      integer*4 dimwork, dimiWork

      character*24 SPcode(nSPtot1)
      character*24 SPcode_user(nSPtot1)
      character*24 PRcode(nPRtot1)
      character*24 PRcode_user(nPRtot1)
      character*42 ADcode(nambtot1)
      character*26 PROcode(nPROtot1)
      integer*4 iSPfit(nSPtot1)
      integer*4 jPRfit(nPRtot1)
      real*4 ambSP(nSPtot1)
      real*4 uambSP(nSPtot1)
      real*4 Atotal(nSPtot1 * nPROtot1)
      real*4 uAtotal(nSPtot1 * nPROtot1)
      integer*4 iWork(dimiWork)
      integer*4 sel
      real*4 work(dimwork)
      integer*4 SFitError, ioption
      integer*4 dimoutbuf, dimerrbuf
      character*(*) outbuf(dimoutbuf)
      character*(*) errbuf(dimerrbuf)
      integer*4 lenoutbuf, lenerrbuf
      character*(*) cWork
      integer*4 action, action1
      integer*4 Sfitbas, uSfitbas
      integer*4 inestim(nPRtot1)
      integer*4 srcFitFlag

      real*4 sngval(nPRtot1)
CX    NB: The following 6 parameter values MUST correspond exactly with those listed in
CX        the Enumerations (@113) in CMB82.c, as well as 
CX        the Internal Constants (@160) listed in Delphi's CMB82Internals.pas:
          integer*4 DO_SetBatchFlag
          parameter ( DO_SetBatchFlag = 4 )

          integer*4 DO_CMB
          parameter ( DO_CMB = 6 )

          integer*4 DO_SendFracEst
          parameter ( DO_SendFracEst = 7 )

          integer*4 DO_SendInfo
          parameter ( DO_SendInfo = 8 )

          integer*4 DO_PData
          parameter ( DO_PData = 10 )

          integer*4 DO_SScont
          parameter ( DO_SScont = 11 )

          integer*4 DO_mPIN
          parameter ( DO_mPIN = 12 )

      include 'CMB82.inc'

C     local variables
      integer*4 error1, Sfitflag
C
C     output title record to Sfit.dat
      Sfitflag = 0
C
      select case ( sel )

C     ************ I ************		Set batch mode, if used; 0 => single sample; 1 => batch mode
      case ( DO_SetBatchFlag )

        batchFlag = action
        fRun = 0

        return

C     ************ II ************
      case ( DO_CMB )
C
      If ( mod(action,4).eq.0 .or. mod(action,4).eq.2 ) then
      call FitAlloc
     &     (
     &      nSPtot1, SPcode,  SPcode_user,
     &      nPRtot1, PRcode,  PRcode_user,
     &      nambtot1, ADcode, nPROtot1, PROcode,
     &      iSPfit,                    jPRfit,
     &      ambSP,                     uambSP,
     &      Atotal, error1
     &      )

C     Check for nSPfit=0 or nPRfit=0 OR nSPfit<nPRfit made in MainFrm.pas' func VerifyCMBRunInputsValid; TC 11/19/04
        if (error1 .eq. ERROR_READ_PROFILE) then ! TC added 11/06/04 to handle ProRec error from SETiWORK
          fRun = ERROR_READ_PROFILE              ! There is a problem reading the source PRofile input file
          return 
        endif

        Sfitbas  = Sfitbase
        uSfitbas = uSfitbase

      Endif

          SFitError = 1
          SourceFitFlag = srcFitFlag

      do while ( SFitError .eq. 1 )
C
         if ( SourceFitFlag .eq. 0 ) then
              SFitError = 0
         endif
C
         call CMBSVD ! 34 arguments
     &      (
     &      action, action1,
     &      nSPfit,   iSPfit,  nPRfit, jPRfit,
     &      work(Afitbase),    work(cHatbase),     work(ucHatbase),
     &      work(Sfitbase),     work(uSfitbase),    sngval,
     &      work(egnvecbase),   work(Uarraybase),
     &      work(veffinvbase), SPcode,       nSPtot,
     &      PRcode,       nPRtot,
     &      PROcode,       NumProRec,
     &      work(workbase), iWork(iWorkbase),
     &      work(workixibase),    work(workix1base),
     &      work(mPINbase),
     &      Atotal,    uAtotal,
     &      ambSP,    uambSP,
     &      errbuf, dimerrbuf, lenerrbuf,
     &      error1 )
C
            if ( error1 .lt. 0 ) then
              fRun = error1
              return
            endif
C
C           Check here if sources need to be eliminated in the fit:
C
            if ( SourceFitFlag.eq.1 ) then
              ioption = 0
              call ChecksFit(
     &          SPcode, SPcode_user, PRcode, PROcode,
     +          work(Sfitbase), nSPtot,
     +          iSPfit, jPRfit,
     +          Atotal, ambSP, SFitError, ioption )
            endif
C
            if ( SourceFitFlag.eq.1 .and. SFitError.eq.1 ) then
c
C             Obtain new fitting source fit:
C
              ioption = 1
              call ChecksFit(
     &          SPcode, SPcode_user, PRcode, PROcode,
     +          work(Sfitbase), nSPtot,
     +          iSPfit, jPRfit, 
     +          Atotal, ambSP, SFitError, ioption )
            endif
C
      enddo

      fRun = error1
      return

C     ************ III ************
      case ( DO_SendFracEst )

          call FracEst
     &        (
     &        nPRfit, sngval, work(egnvecBase), ambSP
     &        )

        fRun = 0
        return

C     ************ IV ************
        case ( DO_SendInfo )

          nSPtot1    = nSPtot
          nSPfit1    = nSPfit
          nPRtot1    = nPRtot
          nPRfit1    = nPRfit
          numCMBfit1 = numCMBfit

          fRun = 0
          return

C     ************ V ************
      case ( DO_PData )

          call PData	         ! 25 arguments as of 10/26/04!
     &        (
     &        nSPfit,
     &        nPRfit,                  jPRfit,
     &        work(cHatbase),          work(ucHatbase),
     &        work(Sfitbase),          work(uSfitbase),
     &        sngval,                  work(egnvecbase),
     &        SPcode,                  nSPtot,
     &        PRcode,                  nPRtot,
     &        work(workbase),          iWork(iWorkbase),
     &        ambSP,                   uambSP,
     &        iSPfit,                  ADcode,
     &        outbuf,                  dimoutbuf,
     &        lenoutbuf,
     &        inestim,                 work(workixibase),
     &        DichotFlag ! Added 10/26/04
     &        )

        fRun = 0
        return

C     ************ VI ************
      case ( DO_SScont )

        nwork = dimwork - workbase + 1

          call SScont  ! 18 arguments
     &      (
     &      nSPfit, nPRfit, jPRfit,
     &      work(Sfitbase),
     &      SPcode,   PROcode, nSPtot,
     &      Atotal,
     &      PRcode,   nPRtot,
     &      work(workbase),     nwork,
     &      ambSP,    uambSP,
     &      outbuf,   dimoutbuf,
     &      lenoutbuf, cWork
     &      )

          fRun = 0
          return

C     ************ VII ************
      case ( DO_mPIN )

          call PIN	! 11 arguments
     &      ( iSPfit, nSPfit, jPRfit,
     &        SPcode,  PRcode,
     &        work( mPINbase ),
     &        work( workbase ),
     &      outbuf,   dimoutbuf,
     &      lenoutbuf, cWork )

          fRun = 0
          return

C
      end select
      return

      return
      end

C***********************************************************************
      subroutine FitAlloc ! 16 arguments
     &    (
     &    nSPtot1, SPcode, SPcode_user,
     &    nPRtot1, PRcode, PRcode_user,
     &    nambtot1, ADcode, nPROtot1, PROcode,
     &    iSPfit, jPRfit,
     &    ambSP, uambSP,
     &    Atotal, error1
     &    )

C	FitAlloc is called by fRun.

      integer*4 nSPtot1, nPRtot1, nambtot1, nPROtot1,  error1
      character*24 SPcode(nSPtot1)
      character*24 SPcode_user(nSPtot1)
      character*24 PRcode(nPRtot1)
      character*24 PRcode_user(nPRtot1)
      character*26 PROcode(nPROtot1)
      character*42 ADcode(nambtot1)
      integer*4 iSPfit(nSPtot1)
      integer*4 jPRfit(nPRtot1)
      real*4 ambSP(nSPtot1), uambSP(nSPtot1)
      real*4 Atotal( nSPtot1, nPROtot1 )
C
      include 'CMB82.inc'
C
C     local variables
C
      integer err
C
      character*12 siteID1
      character*8 date1
      character*2 duration1, start1
      character*6 size1

      error1 = 0
C
      if ( AmbRec.gt.1 .and. g_size.eq.'FINE' ) then
        call SUBATOL ( ADcode(AmbRec-1)(37:42), 6, ambCrec )
        call AmbData( ambCrec, siteID1, date1, duration1, start1,
     &  size1, ambSP, uambSP, err)
C
        if ( size1 .eq. 'COARSE') then
          ambFrec = AMBdirect
        endif
C
      else if ( AmbRec.lt.NumAmbRec .and. g_size.eq.'COARSE' ) then
        call SUBATOL ( ADcode(AmbRec+1)(37:42), 6, ambFrec )
        call AmbData( ambFrec, siteID1, date1, duration1, start1,
     &    size1, ambSP, uambSP, err)
          if ( size1 .eq. 'FINE') then
          ambCrec = AMBdirect
        endif
      endif
C
C     Load siteID, date, duration, start;
C     Load ambSP and uambSP, ambient data arrays:
C
      call AmbData( AMBdirect, siteID1, date1, duration1, start1,
     &              size1, ambSP, uambSP, err)
C
      siteID   = siteID1
      date     = date1
      duration = duration1
      start    = start1
      g_size   = size1

C
C     Set fitting elements and sources:
C
      call SETiWork (SPcode, SPcode_user, PRcode, PRcode_user,
     &    iSPfit, jPRfit, Atotal, ambSP, nSPtot1, nPRtot1,
     &    PROcode, error1 )

      call SETWORK
C
      return
      end

C***********************************************************************
C     Subroutine CMBSVD was modified in April 2003 to replace LINPACK's (linear 
C     algegra library) SVD routine - SSVDC - with LAPACK's SGESVD (see Appendix C 
C     of EPA-CMB8.2 User's Manual).  The LAPACK SVD (singular value decomposition) 
C     SGESVD is better numerically than SSVDC from LINPACK. -TC

C *** Reference:
C     Anderson, E, Z. Bai, C. Bischof, S. Blackford, J. Demmel, J. Dongarra, J. Du Croz, 
C     A. Greenbaum, S. Hammarling, A. McKenney and D. Sorensen, 1999.  LAPACK Users' Guide, 
C     Third Edition.  Society for Industrial and Applied Mathematics (SIAM), Philadelphia, PA;
C     ISBN 0-89871-447-8 (paperback)

C     The entire suite of (single-precision) LAPACK routines is listed and described here:
C     http://www.netlib.org/lapack/single/index.html

C *** The SVD algorithm reduces a matrix to bidiagonal form first, then tries to 
C     diagonalize the bidiagonal matrix B by an iterative algorithm.  If the 
C     iterative algorithm does not converge, INFO returns with a positive value 
C     in SGESVD indicating how many of the superdiagonal elements did not converge 
C     to zero.  The superdiagonal of B is returned in WORK(2:min(M,N)) by SGESVD.  
C     If INFO = 0 on exit from SGESVD, you can ignore the returned value of E/WORK.

      subroutine CMBSVD      !34 arguments
     &  (
     &  action, action1,
     &  nSPfitPR, iSPfit, nPRfitPR, jPRfit,
     &  Afit, cHat, ucHat,
     &  Sfit, uSfit, sngval,
     &  egnvec, Uarray,
     &  veffinv, SPcode, nSPtotPR,
     &  PRcode, nPRtotpr,
     &  PROcode, npro,
     &  work, iWork,
     &  workixi, workix1,
     &  mPIN,
     &  Atot, uAtot,
     &  ambSP, uambSP,
     &  errbuf, dimerrbuf, lenerrbuf,
     &  error1
     &  )

C	CMBSVD is called by f.fRun.

      integer*4
     &  action, action1,
     &  nSPfitPR, iSPfit(nSPfitPR),   nPRfitPR, jPRfit(nPRfitPR),
     &  nSPtotPR, nPRtotpr,  error1,
     &  iWork(nSPtotPR+nPRtotpr), npro,
     &  dimerrbuf, lenerrbuf
C
      character*24 SPcode (nSPtotPR)
      character*24 PRcode (nPRtotpr)
      character*26 PROcode (npro)
      character*(*) errbuf(dimerrbuf)
C
      real*4
     &  Afit(nSPfitPR, nPRfitPR ),  Sfit(nPRfitPR),
     &  work(*),        sngval(nPRfitPR),
     &  egnvec(nPRfitPR,nPRfitPR),
     &  Uarray(nSPfitPR, nSPfitPR),
     &  mPIN(nSPfitPR, nPRfitPR),
     &  uSfit(nPRfitPR),         cHat(nSPtotPR),
     &  ucHat(nSPtotPR),
     &  ambSP(nSPtotPR),      uambSP(nSPtotPR),
     &  Atot(nSPtotPR, npro),     uAtot(nSPtotPR, npro),
     &  workixi( nSPfitPR, nSPfitPR ), workix1(nSPfitPR),
     &  veffinv( nSPfitPR)
C
      include 'CMB82.inc'
C
C     Local variables
      integer
     &  i,        j,        iSP,      jPR,      loop,
     &  MaxLoop,           info,       jj,
     &  workfloor,          nSP,      nPR,      iTMP1,
     &  iFlag, jRec,  iPassFail
C
      integer*4 ProRec
C
C
      real*4
     &  test,     xTMP1,    xTMP2,    xTMP3,    xTMP4,
     &  xTMP5,    sum,      SCEnew,  SCEold,    delta,
     &  Ratio,    posRatio

      character*128 cLine
C	
      logical isBandL, WriteSummary ! BandL = Britt-Luecke algorithm

      save
     &  i,        j,        iSP,      loop,
     &  MaxLoop,           info,        jj,
     &  workfloor,          nSP,      nPR,      iTMP1,
     &  iFlag,    jRec,
     &  test,     xTMP1,    xTMP2,    xTMP3,    xTMP4,
     &  isBandL

      INTEGER               :: LWORK
      REAL*4, ALLOCATABLE   :: YWORK(:)
C
C     allocation of work matrix
C
C     work(1), ..., work(nSP)  store weights
C     work(nSP+1), ..., work(nSP+nPR)  store old solutions
C
C     Initialize; check action required:

C     action = 0 => first call - nonB&L iteration

C     action = 1 => subsequent call with number of additional
C     iterations given by action1.  action1 = 0 => subroutine to
C     procede with no additional iterations.

C     action = 2=> first call - B&L iteration

C     action = action + 4 - perform fit, but do not write to summary file
C                           used with restart to Initialize Sfit, etc.
C
CX     action = 8 - output fitting data only

      CMBSVDerror = 0
	icount = icount + 1

      WriteSummary = .true.
      if ( action.ge.4 .and. action .lt. 8 ) then
        WriteSummary = .false.
        action = action - 4
      endif

CX      if ( action .eq. 8 ) then
CX        goto 7000
CX      endif

      if ( action .eq. 1 ) then
        goto 7000
      else if ( action .eq. 0 ) then
        isBandL = .FALSE.
      else
        isBandL = .TRUE.
      endif

      test      = 0.01
      nSP       = nSPfitPR
      nPR       = nPRfitPR
      workfloor = nSP + nPR

C      MaxLoop = 20	action 1 set in CMBInternals.pas and sent via CMB82.c to fRun.
      MaxLoop = action1
C
C     Check for nSPfit=0 or nPRfit=0 OR nSPfit<nPRfit made in MainFrm.pas' func VerifyCMBRunInputsValid; TC 11/19/04
C     CHECK uambSP:
C
      DO 300 I = 1,nSP
        IF(uambSP(iSPfit(i)) .LE. 0.) THEN
          if ( batchFlag .eq. 0 ) then
C ***     Single sample; user intervention required:
            WRITE(message,400) SPcode( iSPfit(i) )(1:6),
     &            newline(2:2), newline(2:2), newline(2:2)
400         FORMAT(
     &      'Fitting Species ', a6, A1,
     &      'has ZERO Ambient Data Uncertainty!', A1,
     &      'Replace uncertainty with a positive detection limit,', A1,
     &      'or remove the species from the fitting species list.' )
            call WinMessage
 
            CMBSVDerror = ERROR_CMBSVD_2
            error1      = ERROR_CMBSVD_2
C EXIT *************************
            return
C
          else
C ***       Batch Mode; no user intervention allowed:
            CMBSVDerror = ERROR_CMBSVD_2
            error1      = ERROR_CMBSVD_2
            goto 99990

          endif
        ENDIF
C
300   continue
C
C     Initialize Sfit (array for SCEs) and set up source profile records in iWork:
C
      do j = 1, nPR
        Sfit(j) = 0.
        jRec = ProRec ( PRcode( jPRfit(j) ), g_size, PROcode )
C
        if ( jRec .eq. -1 ) then

          if ( batchFlag .eq. 0 ) then
C ***     Single sample; user intervention required:
            write( message, 1100) PRcode( jPRfit(j) ), g_size, char(0)
1100        format (
     &        'No record for source profile code ',a6,
     &        ' and size ', a6, a1)
            call WinMessage

            CMBSVDerror = PROFILE_SET_ERROR
            error1      = PROFILE_SET_ERROR
C EXIT *************************
            return
C
          else
C ***       Batch Mode; no user intervention allowed:
            CMBSVDerror = PROFILE_SET_ERROR
            error1      = PROFILE_SET_ERROR
            goto 99990

          endif
        endif
C
        iWork(j) = jRec
C
      enddo
C
C     Load weighted array into Afit( , ):
C
      do j = 1, nPR
        iFlag = 1
        do i = 1, nSP
          Afit(i,j) = Atot(iSPfit(i), iWork(j) )

          if ( Afit(i,j) .ne. 0. ) iFlag = 0
        enddo
        IF(iFlag .EQ. 1) THEN
C
C       This error condition is caused by a column of the fitting matrix containing 
C       all zeros.  The column corresponds to one of the fitting sources.  A zero 
C       column for a fitting source means that all of the fitting species' fractions 
C       are zero for that source.  The fitting algorithm can't handle a zero column 
C       in the fitting matrix (it's the matrix equivalent of division by zero).
C
          if ( batchFlag .eq. 0 ) then
C ***     Single sample; user intervention required:
            WRITE(message,3320) J, char(0)
3320        FORMAT(
     &        'Column (=source) Number', I5,' of Afit = 0', a1 )
            call WinMessage

            CMBSVDerror = ERROR_CMBSVD_4
            error1      = ERROR_CMBSVD_4
C EXIT *************************
            return
C
          else
C ***       Batch Mode; no user intervention allowed:
            CMBSVDerror = ERROR_CMBSVD_4
            error1      = ERROR_CMBSVD_4
            goto 99990

          endif
        ENDIF
      enddo
C
C     BEGIN ITERATION LOOP
      loop = 0
C
3000  continue
      loop = loop + 1
C
C     Load Veff inverse weights into work(1), ... , work(nSP)
C
      do i = 1,nSP
        iSP = iSPfit(i)
        xTMP1 = uambSP (iSP)
        xTMP1 = xTMP1*xTMP1
        do j = 1,nPR
          xTMP2 = uAtot(iSP, iWork(j))*Sfit(j)
          xTMP1 = xTMP1 + xTMP2*xTMP2
        enddo
        work(i) = 1. / xTMP1
        veffinv(i) = work(i)
      enddo

C     Load previously computed source strengths (SCEs) for later comparison;
C	work(nSP + j) becomes SCEold(j):

      do 3400 j = 1,nPR
        work(nSP + j) = Sfit(j)
3400  continue
C
C     Compute new solution:
C
C     Form atran * Veffinv * a and store in Uarray
C     Store atran * Veffinv in workixi

      do i = 1, nSP
        do j = 1, nPR
          workixi( j, i ) = Afit(i,j) * work(i)
        enddo
      enddo

C     store Atran * Veffinv * A in Uarray

      call MATMUL ( workixi, nPR, nSP, nSPfitPR, Afit, nPR, nSPfitPR,
     &              Uarray, nSPfitPR )
C
C     Store [Atran * Veffinv * A]inverse in egnvec:
C
      call MATSIN ( Uarray, nPR, nSP, egnvec, nPR, info )
C
C     The AKT*VeffIn*AK matrix is used internally by the fitting algorithm.  
C     If one of its columns consists of elements close to zero, the algorithm 
C     has problems because of computer round-off error, in which case MATSIN 
C     returns info = 1.  This condition is usually caused by collinearity among 
C     fitting sources.  Changing fitting sources and/or fitting species is intended 
C     to remove the collinearity.

      IF(info.ne.0) THEN
	  if ( batchflag .eq. 0 ) then
CX        Approptiate message is triggered in Delphi CMB82Internals.pas
          CMBSVDerror = ERROR_CMBSVD_5
          error1      = ERROR_CMBSVD_5
C EXIT *************************
          return
        else
C ***     Batch Mode; no user intervention allowed:
          CMBSVDerror = ERROR_CMBSVD_5
          error1      = ERROR_CMBSVD_5

          goto 99990
        endif
      ENDIF
C
C     Calculate new solutions:
C     Atrans * Veffinv is in workixi
C     [Atran * Veffinv * a]inverse * Atran * Veffinv  in Uarray

      call MATMUL ( egnvec, nPR, nPR, nPRfitPR, workixi, nSP, nSPfitPR,
     &              Uarray, nSPfitPR )

C     New solutions; Sfit is array of SCEs:

      IF ( .not. isBandL ) then
        do j = 1, nPR
          sum = 0.
          do i = 1, nSP
             sum = sum + Uarray(j,i) * ambSP( iSPfit(i) )
          enddo
          Sfit(j) = sum
        enddo
      ELSE
C       This branch for Britt-Luecke algorithm; c - a * sk

        do i = 1, nSP
          sum = 0.
          do j = 1, nPR
            sum = sum + Atot(iSPfit(i), iWork(j) ) * work(nSP+j)
          enddo
          workix1(i) = ambSP( iSPfit(i) ) - sum
        enddo

C       S(k+1) - Sk = [Atran * Veffinv * A]inverse * Atran * Veffinv * ( c - A * sk )

        call MATMUL ( Uarray, nPR, nSP, nSPfitPR, workix1, 1, nSPfitPR,
     &                Sfit, nPRfitPR )

C ***   Calculate Sfit:
        do j = 1, nPR
          Sfit(j) = work(nSP+j) + Sfit(j)
        enddo
      ENDIF

C     Compare new solution to old solutions.
C	Each source is checked and has an equal chance of 'tripping' iPassFail.
C	iPassFail = 0 => pass; iPassFail = 1 => fail
C	If convergence test is unmet for any source, another iteration:

      iPassFail= 0
      do 6000 j = 1, nPR
        SCEnew = Sfit(j)       ! SCEnew = 'new' Sfit(j)
	  SCEold = work(nSP + j) ! SCEold = 'old' Sfit(j) = work(nSP + j)
        delta  =  SCEold - SCEnew
        if (SCEnew .ne. 0.) Ratio = delta/SCEnew
        posratio = abs (Ratio) ! Ratio  = difference / old Sfit(j)
        if (posRatio .gt. test) iPassFail = 1
6000  continue
C
C     Loop again?
C
      IF (iPassFail .ne. 0) THEN			!Branch terminates @868
C	Convergence - don't reiterate!
        if(loop .lt. MaxLoop) then	    !Branch terminates @867
          If ( isBandL ) Then				!Branch terminates @819
C           This branch for Britt-Luecke algorithm only; 
C	      try iterative improvement to Afit.
C           Ak * [aktran * Veffinv * Ak]inverse * Aktran * Veffinv

            call MATMUL ( Afit, nSP, nPR, nSPfitPR,
     &                    Uarray, nSP, nSPfitPR, workixi, nSPfitPR )
C
C           I - Ak * [Aktran * Veffinv * Ak]inverse * Aktran * Veffinv

            do i = 1, nSP
              do j = 1, nSP
                if ( i .eq. j ) then
                  workixi(i,j) = 1. - workixi(i,j)
                else
                  workixi(i,j) = - workixi(i,j)
                endif
              enddo
            enddo

C           Veffinf * {I - Ak * [aktran * Veffinv * Ak]inverse * Aktran * Veffinv}

            do i = 1, nSP
              do j = 1, nSP
                workixi(i,j) = work(i) * workixi(i,j)
              enddo
            enddo

C           c - A * sk

            do i = 1, nSP
              sum = 0.
              do j = 1, nPR
                sum = sum + Atot(iSPfit(i), iWork(j) ) * work(nSP+j)
              enddo
              workix1(i) = ambSP( iSPfit(i) ) - sum
            enddo

C           Veffinf * {I - Ak[Aktran * Veffinv * Ak]inverse * Aktran * Veffinv} X
C           c - A * s  => NEL x 1 in work1

            call MATMUL ( workixi, nSP, nSP, nSPfitPR,
     &                    workix1, 1, nSPfitPR, work , nSPfitPR )

C           N.B.: Work no longer holds Veffinv

            do j = 1, nPR

C           vAj X
C           Veffinv * {I - Ak[aktran * Veffinv * Ak]inverse * Aktran * Veffinv}
C             c - A * s  => NEL x 1 in workix1

              jPR = iWork(j)

              do i = 1, nSP
                iSP = iSPfit(i)
                xTMP2 = uAtot(iSP, jPR )
                xTMP2 = xTMP2 * xTMP2
                workix1(i) =  xTMP2 * work(i)
              enddo

C             Sj * vAj X
C             Veffinf * {I - Ak * [Aktran * Veffinv * Ak]inverse * Aktran * Veffinv}
C             c - A * s  => NEL x 1 in work

              do i = 1, nSP
                workix1(i) =  work( nSP + j ) * workix1(i)
              enddo

C             new Afit:

              do i = 1, nSP
                Afit(i,j) = Atot(iSPfit(i), iWork(j) ) + workix1(i)
              enddo
            enddo
          EndIf
C         Go for another iteration if MaxLoop hasn't been exceeded:
          go to 3000
        else

C         MaxLoop has been exceeded; initialize output buffer:
          call Write2ErrBuf( 0, errbuf, dimerrbuf, cLine,
     &    lenerrbuf )
C
C         GET OPERATOR INTERVENTION:
C
          WRITE(cLine,6110) loop
6110      FORMAT(
     &      'NO CONVERGENCE AFTER ',I3,' ITERATIONS.' )
          call Write2ErrBuf( 1, errbuf, dimerrbuf, cLine,
     &    lenerrbuf )

          write( cLine, '(1h )' )
          call Write2ErrBuf( 1, errbuf, dimerrbuf, cLine,
     &    lenerrbuf )
C
          WRITE(cLine,6120)
6120      FORMAT(' SOURCE    SCEold       Delta    Ratio')
          call Write2ErrBuf( 1, errbuf, dimerrbuf, cLine,
     &    lenerrbuf )

C     Compare new solution to old solutions, again:
C     SCEnew = 'new' Sfit(j)
C     SCEold = 'old' Sfit(j) = work(nSP + j)
C     Ratio  = difference / old Sfit(j)

      DO J=1,nPR
         SCEnew = Sfit(j)
	   SCEold = work(nSP + j)
         delta  =  SCEold - SCEnew
         posratio = 0.
         if (SCEnew .ne. 0.) Ratio = delta/SCEnew
         posratio = abs (Ratio)

         WRITE(cLine,6130) PRcode(jPRfit(J)),SCEold, delta, posratio
6130     FORMAT(1X, a6, 2x, F7.3, 2X, D10.3, 2X, F5.3)
         call Write2ErrBuf( 1, errbuf, dimerrbuf, cLine, lenerrbuf )
      enddo

          call Write2ErrBuf( 2, errbuf, dimerrbuf, cLine, lenerrbuf )
          error1 = ERROR_CMBSVD_6
C EXIT *************************
          return
        endif
      ENDIF
C
7000  continue

C     Check here for action = 1
C	action1 is # iterations chosen in Options (set in CMBinternals.pas)

      if ( action .eq. 1 ) then
        if ( action1 .gt. 0 ) then
          iTMP1 = action1
          action = 0
          MaxLoop = MaxLoop + iTMP1
          goto 3000
        endif
      endif
C
C     End of iteration loop.
C     See below for calculation of uSfit.
C
C     Calculated concentrations and uncertainties as in CMB60:
C
      do 7300 i = 2, nSPtot
        xTMP1 = 0.
        xTMP2 = 0.
        do 7400 j = 1, nPR
          xTMP1 = xTMP1 + Atot(i, iWork(j) )*Sfit(j)
          xTMP3 = uAtot(i, iWork(j) )*Sfit(j)
          xTMP2 = xTMP2 + xTMP3*xTMP3
7400    continue
        cHat(i)  = xTMP1          ! calculated species concentration
        ucHat(i) = sqrt ( xTMP2 ) ! calculated species uncertainty
7300  continue

C	Unclear what this DO-loop does:
      do i = 2, nSP
        xTMP1 = 0.
        do j = 1, nPR
          xTMP1 = xTMP1 + Afit(i,j) * Sfit(j)
        enddo
        cHat(iSPfit(i) ) = xTMP1
      enddo
C
C     Do singular value decomposition.
C     Weight Afit before call to LAPACK's SGESVD:
      do i = 1, nSP
        do j = 1, nPR
          Afit(i,j) = Afit(i,j) * sqrt( veffinv(i) )
        enddo
      enddo
C
C *** LAPACK's SGESVD computes the singular value decomposition (SVD) of a real 
C     M by N matrix A, optionally computing the left and/or right singular vectors.
C     The SVD is written A = U * SIGMA * V**T
C  
C     SGESVD needs LWORK tokens, where LWORK is REAL workspace of length
C     max( 1, max(3*min(M,N) + max(M,N), 5*min(M,N) ) )
C     where
C	M = nSP
C	N = nPR

      LWORK = max( 1, max(3*min(nSP,nPR)+ max(nSP,nPR), 5*min(nSP,nPR)))
      ALLOCATE( YWORK(LWORK) )

C *** LINPACK's SSVDC replaced by LAPACK's SGESVD:
C     jobU  = 'S' => the first min(M,N) columns of U (the left singular vectors) 
C                    are returned in Uarray.
C     jobVT = 'A' => all N rows of V**T are returned in the array VT.

      call SGESVD( 'S', 'A', nSP, nPR, Afit, nSP, sngval, Uarray, nSP, 
     &             egnvec, nPR, YWORK, LWORK, info )

C *** N.B. LINPACK's SVD algorithm (SSVDC) returns the matrix of right singular 
C     vectors V, while the LAPACK's SVD algorithm (SGESVD) returns the transpose 
C     of V, from the formula:
C     A = U * SIGMA * V**T

C *** The egnvec matrices are transposes of each other (they agree to 4 or 5 decimal 
C     places), except that one vector is the negative of the other.  Any multiple 
C     of an eigenvector (or singular vector) is also an eigenvector, so the sign 
C     change is not significant.  Both algorithms (SSVDC & SGESVD) normalize the 
C     vectors so they agree except in sign.

C     If we had repeated singular values, then the situation would get more
C     complicated.  E.g., if we had two singular values at 1.0, then the singular
C     vectors corresponding to those values would span a subspace of dimension
C     two, and the two algorithms might produce totally different basis vectors 
C     for that subspace.  In that case we would have to show that the bases were 
C     equivalent under an orthogonal transformation.  But that isn't necessary 
C     here because the singular values appear to be well separated.

C     The original CMB formulation expects the vectors in the columns of the
C     result matrix.  However, in the LAPACK's SGESVD, they are in the rows of 
C     the result matrix.  To make the egnvec matrix compatible with CMB's 
C     formulation for computating standard errors (and the resultant Tstat), 
C     as well as mPIN values, we need to transpose the vector V on return from 
C     SGESVD.  The following section transposes the nPR X nPR matrix egnvec:

      do j = 1, nPR
         do i = j+1, nPR
            TMP = egnvec(i,j)
            egnvec(i,j) = egnvec(j,i)
            egnvec(j,i) = TMP
         end do
      end do

C     Source uncertainties
C
      do j = 1, nPR
         do i = 1, nPR
            work(workfloor+i) = 0.

            if ( i .eq. j ) then
              work(workfloor+i) = 1.
            endif
         enddo

C *** xTMP1 {= Sfit(j), computed @720} & xTMP2 {computed by XLCunc, = STDERR(j)} are returned in XLCunc call.
        call XLCunc ( nPR, work(workfloor + 1), Sfit, egnvec, sngval,
     &                xTMP1, xTMP2 )
        uSfit(j) = xTMP2

      enddo

C     Total mass

      do 7500 j = 1,nPR
        work(workfloor + j) = 1.
7500  continue
      call XLCunc ( nPR, work(workfloor + 1), Sfit, egnvec, sngval,
     &              xTMP1,  xTMP2 )

      cHat(1)  = xTMP1   ! = TOTAL calculated mass (all sources/species) = sum SCEs
      sumSCEs  = cHat(1) ! Handoff to global var. for use in Step V of CMB82.c;
	                   ! See Line 1600 for update when sixeTMP = TOTAL
      ucHat(1) = xTMP2   ! = TOTAL calculated uncertainty (all sources/species)
C
C     Calculate Degrees of Freedom (DF = DegFree), reduced Chi Square (CHIsqr), 
C	RSquare (Rsquare), & % mass explained (pcntMass}
C
      DegFree = nSP - nPR
C
      xTMP3 = 0.
      xTMP4 = 0.
      do 8000 i = 1,nSP
        xTMP5 = sqrt( veffinv(i) )
        xTMP1 = xTMP5*ambSP(iSPfit(i))
        xTMP2 = xTMP5*cHat(iSPfit(i))
        xTMP2 = xTMP1 - xTMP2
        xTMP3 = xTMP3 + xTMP1*xTMP1
        xTMP4 = xTMP4 + xTMP2*xTMP2
8000  continue
      CHIsqr = 0.
      if (DegFree .gt. 0) CHIsqr = xTMP4/DegFree
C
      Rsquare = 0.
      if (xTMP3 .ne. 0.) Rsquare = 1. - xTMP4/xTMP3
      pcntMass = 0.
      IF(ambSP(1) .NE. 0.) pcntMass = 100. * cHat(1)/ambSP(1) ! cHat(1) = sum SCEs
C
C     Store modified pseudo inverse (PIN) matrix in mPIN:
C
      do 9000 i = 1, nSP
C
C       Load mPIN( i, j ), j = 1, nPR  in work( j + nSPfit ):
C
        do 9100 j = 1, nPR
          work(j + nSP ) = 0.
          do 9200 jj = 1, nPR
            work(j + nSP) = work(j + nSP)
     &       + Uarray( i, jj)*egnvec( j, jj)/sngval(jj)
9200      continue
9100    continue
C
        do 9300 j = 1, nPR
           mPIN( i, j ) = work( j + nSPfit )
9300    continue
9000  continue
C
C     Normalize mPIN over species:

C
      do 9400 j = 1, nPR
         xTMP1 = 0.
C
         do 9500 i = 1, nSP
            xTMP1 = amax1( xTMP1, abs( mPIN( i, j ) ) )
9500     continue
C	mPIN array holds final values that appear in MPIN display in Main Report:
         if( xTMP1 .ne. 0. ) then
            do 9600 i = 1, nSP
               mPIN( i, j) = mPIN( i, j)/xTMP1
9600        continue
         endif
C
9400  continue
C
C     Write data to summary file:
C
      do 8100 j           = 1, nPRtot
         work(j)          = miss
         work(nPRtot + j) = 0.
8100  continue
C
      do 8200 j = 1, nPRfit
         work(jPRfit(j))          =  Sfit(j)
         work(nPRtot + jPRfit(j)) = uSfit(j)
8200  continue

C
C     Write fitting info to summary file.
C     Store fitting elements and sources in iWork first:
C
99990 continue
C *** Dimension iWork to {nSPtot + nPRtot} and set all array elements to zero.
C     Then set elements for specific fitting species and fitting sources to 1:

      do i = 1, nSPtot+nPRtot
         iWork(i) = 0
      enddo

      do i = 1, nSPfit
         iWork(iSPfit(i)) = 1
      enddo
C
      do j = 1, nPRfit
         iWork(nSPtot+jPRfit(j)) = 1
      enddo
C
C EXIT *************************

      if ( .not. WriteSummary ) then
C EXIT *************************
        return
      endif

        if ( action .eq. 8 ) then
C EXIT *************************
          return
        endif

      numCMBfit = numCMBfit + 1
C
      call OpenSumDir

      write ( SumDirUn, rec = numCMBfit ) AMBdirect,
     &  ( iWork(i), i = 1, nSPtot+nPRtot),
     &  ( work(j), j = 1, 2 * nPRtot ),
     &  ( cHat(i), i = 1, nSPtot ),
     &  ( ucHat(i), i = 1, nSPtot )

      close( SumDirUn )

C
C EXIT *************************
      error1 = numCMBfit
      return

C *** DEallocate SGESVD's workspace:
      DEALLOCATE( YWORK )

      end

C***********************************************************************
      subroutine ChecksFit (
     &  SPcode, SPcode_user, PRcode, PROcode, Sfit, nSPtotPR, iSPfit, 
     &  jPRfit, Atotal, ambSP, fiterror, ioption )

C     ChecksFit is called by s.CMBSVD.  It checks the fit for sources to eliminate.
C     If ioption = 0, the subroutine sets fiterror = 1 and returns;
C     otherwise, the subroutine changes the fitting species by eliminating:
C     1. the source with the most negative contribution, or
C     2. if no negative sources exist, the subroutine eliminates the
C        source with the largest TMP2  = uSfit(j) / Sfit(j) satisfying
C        the elimination criterion.

C     970104 removed elimination criteria #2.  Now only negative are eliminated sources. (NR)
C
      integer*4 nSPtotPR, iSPfit(*), jPRfit(*)
      integer*4 fiterror, ioption
      real*4 Atotal( nSPtotPR, * ), ambSP(*)
      real*4 Sfit(*)
      character*24 SPcode(*)
      character*24 SPcode_user(*)
      character*24 PRcode(*)
      character*26 PROcode(*)
C
      include 'CMB82.inc'
C
C     local variables
C
      integer*4 jPRbad, j, jPR, jFlag
      real*4 TMP1
      real*4 MAXsrcUncAbs
C
C     Test for sources with negative contributions:
C
      jPRbad = 0
      TMP1 = 0
      fiterror = 0

      MAXsrcUncAbs = MAXsourceUnc * ambSP(1) / 100.
C
C     Do not eliminate all sources:
C
      if ( nPRfit .eq. 1 ) then
        return
      endif
C
C     Check for negative source contributions:
C
      do j = 1, nPRfit

        if ( Sfit(j) .lt. TMP1 ) then
C
          TMP1 = Sfit(J)
          jPRbad = j
        endif

      enddo

      if ( jPRbad .gt. 0 ) then
        fiterror = 1

        if( ioption .eq. 0 ) then
          return
        else
          jFlag = 15 + 2*sizeNDX
          jPR = jPRfit(jPRbad)
          PRcode(jPR)( jFlag:jFlag ) = ' '
C
C         pass PRcode in place of PRcode_user to SETiWork to
C         preserve default values in PRcode_user
          call SETiWork (SPcode, SPcode_user, PRcode, PRcode,
     &      iSPfit, jPRfit, Atotal, ambSP, nSPtot, nPRtot, PROcode,
     &      error1 )
          call SETWORK
        endif

      endif
C
      return
      end

C***********************************************************************
      subroutine FracEst ( nPRfitPR, sngval, egnvec, ambSP )

C	FracEst is called by fRun.

      integer nPRfitPR

      real*4 sngval(nPRfitPR)
      real*4 egnvec(nPRfitPR,nPRfitPR)
	real*4 Proj(nPRfitPR)                            !TC added 4-01-05
      real*4 ambSP(*)

      include 'CMB82.inc'

      integer*4 DimEligible
      integer*4 numESTsource
      integer*4 i, j
      real*4 xTMP1, SUMegnSQRs
      real*4 MAXsrcUncAbs

      MAXsrcUncAbs = MAXsourceUnc * ambSP(1) / 100.

      do j = 1, nPRfit+1

        if ( j .le. nPRfit ) then

          if ( 1. / sngval(j) .gt. MAXsrcUncAbs ) then
            DimEligible = j - 1
            exit
          endif

        else
          DimEligible = nPRfit
        endif

      enddo

C     Determine number of estimable sources:

      numESTsource = 0
      do i = 1, nPRfit
        SUMegnSQRs = 0.
        do j = 1, DimEligible
          SUMegnSQRs = SUMegnSQRs + egnvec(i,j) * egnvec(i,j)
        enddo

        Proj(i) = sqrt( SUMegnSQRs ) !Set the Projection value for this fitting source; TC 4-01-05
        if ( Proj(i) .ge. minSourceProj ) then
          numESTSource = numESTsource + 1
        endif

      enddo

CX      fracestim = numestsource
CX      fracestim = fracestim / nPRtot                ! Denominator should be nPRfit, NOT nPRtot!!
	FracEstim = float(numESTsource) / float(nPRfit) ! TC revised this expression 02/01/05

      return
      end

C***********************************************************************
C     PData
C
C     This subroutine is called by fRun controls the generation of the 
C	Main Report.  It will output a total section when colocated samples 
C	are detected, i.e., when:
C	SIZE = FINE and a previous fit has been made to size COARSE or 
C	SIZE = COARSE and a previous fit has been made to size FINE
C	and both fits have identical fitting species and fitting sources.

      subroutine PData         ! 25 arguments as of 10/26/04
     &  (
     &  nSPfitPR,
     &  nPRfitPR,                      jPRfit,
     &  cHat,                          ucHat,
     &  Sfit,                          uSfit,
     &  sngval,                        egnvec,
     &  SPcode,                        nSPtotPR,
     &  PRcode,                        nPRtotPR,
     &  work,                          iWork,
     &  ambSP,                         uambSP,
     &  iSPfit,                        ADcode,
     &  outbuf,                       dimoutbuf,
     &  lenoutbuf,
     &  indexInEST,                   workixi,
     &  DichotFlag ! Added 10/26/04 -TC
     &  )
C
      integer*4 
     &  nSPfitPR, nPRfitPR, iSPfit(nSPfitPR), jPRfit(nPRfitPR),
     &  nSPtotPR, nPRtotPR, dimoutbuf, lenoutbuf, DichotFlag ! DichotFlag added 10/26/04 -TC
C
      character*24 SPcode (nSPtotPR)
      character*24 PRcode (nPRtotPR)
      character*42 ADcode(*)
      character*(*) outbuf(dimoutbuf)
C
      integer*4 iWork(*)
      integer*4 indexInEST(nPRfitPR)
C
      real*4
     &  Sfit(nPRfitPR),
     &  work(*),        sngval(nPRfitPR),
     &  egnvec(nPRfitPR, nPRfitPR),
     &  uSfit(nPRfitPR),         cHat(nSPtotPR),
     &  ucHat(nSPtotPR),
     &  ambSP(nSPtotPR),      uambSP(nSPtotPR),
     &  workixi( nSPfitPR, nSPfitPR )
C
      include 'CMB82.inc'
C
C     Local variables:
C
      integer dirUnit, nPR, error1, iLine, j, jPR
      integer i, iTMP
      integer nSfit, nuSfit, ncHat, nucHat, nambSP, nuambSP
      integer*4 writeflag, dichotCoarse, dichotFine
C
C
      character*12 siteID1
      character*8  date1
      character*2  duration1, start1
      character*6  pronum, size1, sizeTMP
      character*8  sname
      character*79 char79
C
      real*4 ambSmass, UambSmass, Tstat
      real*4 ambFmass, UambFmass, ambCmass, UambCmass,ambTmass,UambTmass
      real*4 ambFmassL, UambFmassL, ambCmassL, UambCmassL ! ADDED 11/01/04
      real*4 res, sigres, ressig
      real*4 Ratio, uRatio
      real*4 xTMP1, xTMP2, sign
      integer*4 TOTALflag
      integer*4 CSumDirect
      integer*4 FSumDirect
      integer*4 CAMBdirect
      integer*4 FAMBdirect
      integer*4 n, info
      logical   Dichot
      integer*4 AMBdirect1
      integer*4 DimEligible
	integer nRows, nOut, nInner, icol, InEST
      integer numInESTsource
      integer numESTsource
      integer numtoks, lentok

      integer*2 nLine, LineLen
      character*128 cLine
      character*23 format1
      character*84 format2
      character*50 format3
      character*50 format3a
      character*20 format4
      character*3  YesNo

      real*4 MAXsrcUncAbs, Proj !TC added Proj 4-01-05 (parallel w/ s.FracEst)

      integer nn
      integer sngvalOK

C *** MOD 03/27/03, per E Anderson:
      INTEGER             :: LWORK
      REAL*4, ALLOCATABLE :: YWORK(:)
C *** endmod

      data format1 / '(A3,1X,A6,1X,A8,3F11.5)' /
      data format2 /
CX   & '(a6,1X,A6,1X,A1,1x,F8.5,''+-'',F8.5,1X,F8.5,''+-'',F8.5,2X,F5.2,
CX    TC revised formats in the format 2 to accommodate the combined (TOTAL)
CX    report when fine & coarse size fractions are used, where mass may be >= 100 
     & '(a6,1X,A6,1X,A1,1x,F9.5,''+-'',F8.5,1X,F9.5,''+-'',F8.5,2X,F5.2,
     &''+-'',F5.2,1X,F7.1)' /
      data format3 / '(F8.5,2x,''('',F3.0,''% OF TOTAL MEAS. MASS)'')'/
      data format3a / '(F9.5)'/
      data format4 / '(F8.5,2x)'/

      save format1
C
C     ******************************
C
      nLine   =  0
      dirUnit = AmbDirUn
C
C     Set work array pointers to store display data:
C
      nSfit   = 2*nSPtot + 2*nPRtot
      nuSfit  = nSfit + nPRtot
      ncHat   = nuSfit + nSPtot
      nucHat  = ncHat + nSPtot
      nambSP  = nucHat + nSPtot
      nuambSP = nambSP + nSPtot
      nwork   = nuambSP + nSPtot
C
      ambFmass  = miss
      UambFmass = miss
      ambCmass  = miss
      UambCmass = miss
C
C     Get fine and coarse totals.
C
      TOTALflag = 0
      sizeTMP = g_size
      MAXsrcUncAbs = MAXsourceUnc * ambSP(1) / 100.

      call OpenSumDir
C     numCMBfit is set at end of s.CMBSVD; it controls the record in which SumDirect is written in s. CMBSVD
      if ( sizeTMP .eq. 'COARSE' ) then
        CSumDirect = numCMBfit
        ambCmass   = ambSP(1)
        UambCmass  = UambSP(1)
        ambCmassL  = ambCmass ! TC added 11/01/04 to hold last values for TOTAL report
        UambCmassL = UambCmass! TC added 11/01/04 to hold last values for TOTAL report
      endif
C
      if ( sizeTMP .eq. 'FINE' ) then
        FSumDirect = numCMBfit
        ambFmass   = ambSP(1)
        UambFmass  = UambSP(1)
        ambFmassL  = ambFmass  ! TC added 11/01/04 to hold last values for TOTAL report
        UambFmassL = UambFmass ! TC added 11/01/04 to hold last values for TOTAL report
      endif
C
      nPR = nPRfit
C
C     Initialize output buffer
C
      call Write2OutBuf( 0, outbuf, dimoutbuf, cLine,
     &  lenoutbuf )
C
C     Entry point for TOTAL report assembly & output:
C
100   continue
C-------------------------------------------------------------------------------
      IF ( sizeTMP .eq. 'TOTAL' ) THEN               ! Only set @ LINE 2297; Branch terminates @1553
                                                     ! Here, we create the TOTAL report:
        ambSmass  = ambFmass + ambCmass  ! Accumulation is here for fine (ambFmass) & coarse (ambCmass)
        UambSmass = sqrt( UambFmass*UambFmass + UambCmass*UambCmass )
C
C       << FINE >>
C
        read( SumDirUn, rec = FSumDirect ) FAMBdirect,
     &    (iWork(i), i = 1, nSPtot+nPRtot ),
     &    (work(j), j = 1, 2 * nPRtot + 2 * nSPtot )
C
C	Initialize work(nSfit+j) & work(nuSfit+j):
        do j = 1, nPRfit
          work(nSfit+j) = work( jPRfit(j) )
          work(nuSfit+j) = work( nPRtot+jPRfit(j) )
        enddo
C
        do i = 1, nSPtot
          work(ncHat+i) = work(2*nPRtot + i )
          work(nucHat+i) = work(2*nPRtot + nSPtot + i )
        enddo
C
C
        call AmbData( FAMBdirect, siteID1, date1, duration1, start1,
     &    size1, work, work(nSPtot+1), error1)
C
        do i = 1, nSPtot
          work(nambSP+i) = work(i)
          work(nuambSP+i) = work(nSPtot+i)
        enddo
C
C       << COARSE >>
C
        read( SumDirUn, rec = CSumDirect ) CAMBdirect,
     &    (iWork(i), i = 1, nSPtot+nPRtot ),
     &    (work(j), j = 1, 2 * nPRtot + 2 * nSPtot )
C
        do j = 1, nPRfit
C
          if( abs( work( jPRfit(j) ) - miss ) .gt. 1.e-5  .and.
C
     &      abs( work(   nSfit+j ) - miss ) .gt. 1.e-5 ) then

C	N.B. work(nSfit+j) & work(nuSfit+j) are calculated indepentently from 
C	nSfit and nuSfit; see DO-Loop (THIS LOOP) @1539).  These are used to calculate 
C     Tstat @1669.

            work(nSfit+j)  = work(nSfit+j) + work( jPRfit(j) )
            xTMP1          = work(nuSfit+j)*work(nuSfit+j)
            work(nuSfit+j) =
     &        sqrt( xTMP1 + work( nPRtot+jPRfit(j) )
     &                    * work( nPRtot+jPRfit(j) ) )
C
          else
C
            work(nSfit+j)  = miss
            work(nuSfit+j) = miss
C
          endif
C
        enddo
C
        do i = 1, nSPtot
          work(ncHat+i) = work(ncHat+i) + work(2*nPRtot+i)
          work(nucHat+i) = work(nucHat+i)*work(nucHat+i)
          work(nucHat+i) =
     &      sqrt( work(nucHat+i) +
     &      work(2*nPRtot+nSPtot+i)*work(2*nPRtot+nSPtot+i) )
        enddo
C
        call AmbData( CAMBdirect, siteID1, date1, duration1, start1,
     &    size1, work, work(nSPtot+1), error1)
C
        do i = 1, nSPtot
          work(nambSP+i) = work(nambSP+i) + work(i)
        work(nuambSP+i) = work(nuambSP+i)*work(nuambSP+i)
          work(nuambSP+i) =
     &      sqrt( work(nuambSP+i) + work(nSPtot+i)*work(nSPtot+i) )
        enddo
C
C       End of 'TOTAL' if block.
C
      ELSE
C
C       Load ambSP and uambSP, ambient data arrays:
C	  Control goes to here if NOT making a return from 2420,
C	  the only place where sizeTMP is set to TOTAL:

        call AmbData( AMBdirect, siteID1, date1, duration1, start1,
     &                size1, ambSP, uambSP, error1)
        ambSmass  = ambSP(1) ! Total measured mass for thguis size fraction
        UambSmass = uambSP(1) ! Uncertainty ...

C	THIS LOOP; Sfit(j) = SCE(j); uSfit(j) = StdErr(j); computed by s.CMBSVD @720 & @987, resp.
C     Update work(nSfit+j) & work(nuSfit+j):
        do j = 1, nPR
          work(nSfit+j)  =  Sfit(j)
          work(nuSfit+j) = uSfit(j)
        enddo
C
        do i = 1, nSPtot
          work(ncHat+i)   = cHat(i)   ! CALCULATED concentration
	    CalConc(i)      = cHat(i)   ! Load CalConc array for use in s.SFitOut; 09/13/04 -tc
          work(nucHat+i)  = ucHat(i)  ! CALCULATED uncertainty
	    CalcUnc(i)      = ucHat(i)  ! Load CalcUnc array for use in s.SFitOut; 09/13/04 -tc
          work(nambSP+i)  = ambSP(i)  ! MEASURED concentration
          work(nuambSP+i) = uambSP(i) !     "    uncertainty
        enddo
C
      ENDIF
C-------------------------------------------------------------------------------
CX    Generate header for Main Report:
CX    Calculate sumSCEs and % Mass for the 'Total' part of this report (if needed):
CX    >>  pcntMass = 0. ! Don't seem to need this zero initialization
CX    For dichot samples, on the 3rd pass, the updates to sumSCEs and pcntMass are necessary, 
CX    and done NOwhere else!
      if(ambSmass .NE. 0.) then
        sumSCEs  = work(ncHat+1) !in s. CMBSVD, was defined as sumSCEs = cHat(1) Line 1047
	  pcntMass = 100. * work(ncHat+1)/ambSmass
	endif

      WRITE( cLine, 1000) siteID, date, VERNUM
1000  FORMAT('SOURCE CONTRIBUTION ESTIMATES - '
     &  , ' SITE: ',A12,' DATE: ',A8,1X,'    CMB ',A3)
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      WRITE(cLine,
     &  '(''SAMPLE DURATION'',a10,6X,''START HOUR'',
     &  a10,8X,''SIZE: '',A8 )' )
     &    duration, START, sizeTMP
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,
     &  '(7X,''R SQUARE'',F10.2,4X,''PERCENT MASS'',F10.1 )' )
     &  Rsquare, pcntMass
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,
     &  '(5x,''CHI SQUARE'',F10.2,14x,''DF'',I10)' )
     &  CHIsqr, DegFree
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      nLine = nLine + 1
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      nLine = nLine + 1
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      nLine = nLine + 1
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,
     &  '( ''SOURCE'' )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,                                     ! Present SCE statistics:
     &  '( ''EST CODE   NAME     SCE(UG/M3)    Std Err      Tstat'' )')
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      WRITE(cLine,'( 52(1H-) )')
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      iLine = 9
C
C     Determine estimable sources:
C
C     Determine eigenvectors spanning eligible space;
C     This set of eigenvectors is determined by
C     1 / sngval <= MAXsrcUncAbs (i.e., <= maximum absolute source uncertainty)

      sngvalOK = 1
      do j = 1, nPRfit+1

        if ( j .le. nPRfit ) then

          if (sngval(j) .lt. 1.e-10 ) then
            DimEligible = j - 1
            sngvalOK = 0
            exit
          endif

          if ( 1. / sngval(j) .gt. MAXsrcUncAbs ) then
            DimEligible = j - 1
            exit
          endif

        else
          DimEligible = nPRfit
        endif

      enddo

C     Index INestimable sources

      numInESTsource = 0

      do j = 1, nPRfit
        indexInEST(j) = 0
      enddo

      do i = 1, nPRfit

        xTMP1 = 0.
        do j = 1, DimEligible
          xTMP1 = xTMP1 + egnvec(i,j) * egnvec(i,j)
        enddo

        if ( sqrt( xTMP1 ) .lt. minSourceProj ) then
          numInESTsource = numInESTsource + 1
          indexInEST(numInESTsource) = i
        endif

      enddo

      numESTsource = nPR - numInESTsource

      write( format1(22:22), '(i1)' ) displayDecPl

C     Calculate Tstat for Main Report:
      DO j = 1,nPR
        jPR   = jPRfit(j)
        Tstat = 0.
        IF(work(nuSfit+j) .NE. 0.)
     +    Tstat = work(nSfit+j)/work(nuSfit+j)
C

        pronum = PRcode(jPR)(1:6)
        sname  = PRcode(jPR)(8:15)
C
        iLine = iLine + 1
C
      YesNo = 'YES'
        do nn = 1, numInESTsource

          if ( indexInEST(nn) .eq. j ) then
            YesNo = 'NO '
          endif

        enddo

        WRITE(cLine,format1)
     &    YesNo, PRONUM, SNAME, work(nSfit+j), work(nuSfit+j), Tstat
2100    FORMAT( A6,1X,A8,3F11.4 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      ENDDO
C
      iLine = iLine + 1
      WRITE(cLine,'( 52(1H-) )')
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      iLine = iLine + 3
C-------------------------------------------------------------------------------
C     Check for size FINE or COARSE for FINE/COARSE/TOTAL ambient concentrations:
C
      IF ( sizeTMP .eq. 'FINE' ) THEN			!Branch terminates @1738
C
        ambCmass = miss
        if ( AmbRec .gt. 1 ) then
          call GetAMBdirect( ADcode, AmbRec-1, AMBdirect1 )
C
          call AmbData( AMBdirect1, siteID1, date1, duration1, start1,
     &                  size1, work(1), work(nSPtot+1), error1)
C
          if ( siteID1 .eq. siteID   .and.
     &           date1 .eq. date     .and.
     &       duration1 .eq. duration .and.
     &          start1 .eq. start    .and.
     &           size1 .eq. 'COARSE' ) then
            ambCmass  = work(1)         ! work(1) = SCE for the 1st source
            UambCmass = work(nSPtot+1)
          endif
        endif
C
      ELSE IF ( sizeTMP .eq. 'COARSE' ) THEN
C
        ambFmass = miss
        if ( AmbRec .lt. NumAmbRec ) then
           call GetAMBdirect( ADcode, AmbRec+1, AMBdirect1 )
C
           call AmbData( AMBdirect1, siteID1, date1, duration1, start1,
     &       size1, work(1), work(nSPtot+1), error1)
C
           if ( siteID1 .eq. siteID   .and.
     &            date1 .eq. date     .and.
     &        duration1 .eq. duration .and.
     &           start1 .eq. start    .and.
     &            size1 .eq. 'FINE' ) then
               ambFmass = work(1)        ! work(1) = SCE for the 1st source
              UambFmass = work(nSPtot+1)
           endif
        endif
      ENDIF
C-------------------------------------------------------------------------------
      IF ( abs( ambFmass - miss ) .gt. 1.e-5 .and.	!Branch terminates @1775
     +        abs( ambCmass - miss ) .gt. 1.e-5 ) THEN
        ambTmass  = ambFmass + ambCmass ! summing is here for fine (ambFmass) & coarse (ambCmass)
        UambTmass = sqrt( UambFmass*UambFmass + UambCmass*UambCmass )

      nLine = nLine + 1
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

CX    Using this cascade, generate Footer for MEASURED values for DICHOT samples:  TC 09/16/04
      If (sizeTMP .eq. 'COARSE') Then
        write(cLine, 2200) sizeTMP
2200    format( 'Dichotomous Sample(s); Measured Concentration/Uncertain
     &ty for Size: ', A6 )
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        write(cLine, 2210) ambCmass, UambCmass
2210    format(17x, F10.1, '+-', F8.1)
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
	
	ElseIf (sizeTMP .eq. 'FINE') Then
        write(cLine, 2200) sizeTMP
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        write(cLine,2220) ambFmass, UambFmass
2220    format(17x, F10.1, '+-', F8.1)
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
	
	ElseIf (sizeTMP .eq. 'TOTAL') Then
        write(cLine, 2200) sizeTMP
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        write(cLine, 2230) ambTmass, UambTmass
2230    format(18x, F10.1, '+-', F8.1)
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
	  cLine = ' '
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      EndIf
C-------------------------------------------------------------------------------
cx      WRITE(cLine,
cx     &  '( ''MEASURED CONCENTRATION FINE/COARSE/TOTAL:'' )' )
cx      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

cx        WRITE(cLine,2300) ambFmass,UambFmass,ambCmass,UambCmass,
cx     &                    ambTmass,UambTmass
cx      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
2300    FORMAT(2(F10.1,'+-',F8.1,'/'),F10.1,'+-',F8.1)
C
      ELSE
C	non-colocated samples are handled on this branch:
      nLine = nLine + 1
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        WRITE(cLine,2400) sizeTMP
2400    FORMAT('MEASURED CONCENTRATION FOR SIZE: ',A6)
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        WRITE(cLine,2500) ambSmass,UambSmass
2500    FORMAT( F10.1,'+-',F8.1 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      ENDIF
C===============================================================================
      IF( sngvalOK .eq. 1 .and. CMBSVDerror .eq. 0 .and.	!Branch terminates @2070
     &    sizeTMP .ne. 'TOTAL' ) THEN

      iLine = 4
C     We define Q transpose here in order to get eigenvectors to
C     Q * Q transpose in V

        do i = 1, numInESTsource
          do j = 1, nPRfit
            workixi(j,i) = egnvec(indexInEST(i),j) / sngval(j)
          enddo
        enddo

C       compute right singular vectors
        if ( numInESTsource > 0 ) then

C *** LINPACK's SVD routine - SSVDC - has been replaced by LAPACK's SGESVD (see 
C     CMBSVD, above).
C     LAPACK's SGESVD needs LWORK tokens, where LWORK is REAL workspace of length
C     max( 1, max(3*min(M,N) + max(M,N), 5*min(M,N) ) )
C     where
C	M = nPRfit
C	N = numInESTsource
	
C     Allocate workspace for call:
      LWORK = max( 1, 3*min(nPRfit,numInESTsource) +
     &        max(nPRfit,numInESTsource), 5*min(nPRfit,numInESTsource))
      ALLOCATE( YWORK(LWORK) )

C *** LINPACK's SSVDC replaced by LAPACK's SGESVD:
C     jobU  = 'N' => no columns of U (no left singular vectors) are computed.
C     jobVT = 'O' => since N .le. M (i.e., numInESTsource .le. nPRfit), the first 
C                    min(M,N) rows of V**T (the right singular vectors) are 
C                    overwritten on the array A (here, workixi).

      call SGESVD( 'N', 'O', nPRfit, numInESTsource, workixi, nSPfitPR,
     &             work(1), workixi, nSPfitPR, workixi, nSPfitPR, 
     &             YWORK, LWORK, info )

C *** NB: unlike in earlier call to s.SGESVD in s.CMBSVD (@965),
C         we do NOT transpose the egnvec matrix!
      endif

C      Write Eligible Space Display:

        cLine = ' '
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

C	 R Albury added the following 8 lines 1/03:
        cLine = '                   Eligible Space Collinearity Display'
        call Write2OutBuf(1, outbuf, dimoutbuf, cLine, lenoutbuf )
        WRITE(cLine,'( 80(1H=) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        WRITE( cLine(1:42),
     &   '( ''ELIGIBLE SPACE DIM. = '', i3, '' FOR MAX. UNC. = '' )' )
     &     DimEligible
        write( format3(5:5), '(i1)' ) displayDecPl
        WRITE(cLine(43:80), format3 ) MAXsrcUncAbs, MAXsourceUnc
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = '1 / Singular Value'
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        WRITE(cLine,'( 80(1H-) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        numtoks = 8
        lentok = 10
        xTMP1 = real( nPR - 1 ) / numtoks
        nRows = ifix( xTMP1 ) + 1

        write( format4(5:5), '(i1)' ) displayDecPl

        do nOut = 1, nRows
          icol = 1
          writeflag = 0
          cLine = ' '
          do nInner = 1, numtoks
            n = numtoks * ( nOut - 1 ) + nInner

            if ( n .gt. nPR ) then
              goto 3000
            endif

            write( cLine(icol:icol+lentok-1), format4 )
     &        1. / sngval(n)
            icol = icol + lentok
            writeflag = 1

          enddo

          call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
          writeflag = 0

        enddo

3000    continue

        if ( writeflag .eq. 1 ) then
          call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        endif

        WRITE(cLine,'( 80(1H-) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

C       Output estimable sources;
C       number or rows required for estimable sources record

        cLine = ' '
        write( cLine(1:30), '( ''NUMBER ESTIMABLE SOURCES = '', i3 )' )
     &   numestsource
        WRITE(cLine(31:80),
     &   '( '' FOR MIN. PROJ. = '', f5.2 )' ) minsourceproj
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        write( cLine(1:30),
     &    '( '' PROJ. SOURCE   PROJ. SOURCE  '' )' )
        write( cLine(31:60),
     &    '( '' PROJ. SOURCE   PROJ. SOURCE  '' )' )
        write( cLine(61:80),
     &    '( '' PROJ. SOURCE'' )' )
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        WRITE(cLine,'( 80(1H-) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        numtoks = 5
        lentok  = 15
        xTMP1   = real( nPR - 1 ) / numtoks
        nRows   = ifix( xTMP1 ) + 1

        do nOut = 1, nRows
          icol = 1
          writeflag = 0
          cLine = ' '
          do nInner = 1, numtoks
            n = numtoks * ( nOut - 1 ) + nInner

            if ( n .gt. nPR ) then 
              goto 3100
            endif

            xTMP1 = 0.
            do j = 1, DimEligible
              xTMP1 = xTMP1 + egnvec(n,j) * egnvec(n,j) !Accumulate sum of squares of EgnVec vals.
            enddo

            Proj = sqrt( xTMP1 ) !TC refactored; replaced (updated) xTMP1 with Proj; 4-01-05
            jPR = jPRfit( n )
            write( cLine(icol:icol+lentok-1), '( f6.4, 1x, a6, 2x )' )
     &        Proj, PRcode(jPR)(1:6)
            icol = icol + lentok
            writeflag = 1

          enddo

          call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
          writeflag = 0

        enddo

3100    continue

        if ( writeflag .eq. 1 ) then
          call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
        endif

        WRITE(cLine,'( 80(1H-) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        write( cLine,
     &    '( ''ESTIMABLE LINEAR COMBINATIONS OF '',
     &       ''INESTIMABLE SOURCES'' )' )
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        cLine = ' '
        write( cLine(1:30),
     &    '( ''COEFF. SOURCE  COEFF. SOURCE  '' )' )
        write( cLine(31:60),
     &    '( ''COEFF. SOURCE  COEFF. SOURCE  '' )' )
        write( cLine(61:80),
     &    '( '' SCE         Std Err'' )' )
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        WRITE(cLine,'( 80(1H-) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

        xTMP1 = MAXsrcUncAbs * MAXsrcUncAbs
        do InEST = numInESTsource,
     &    numInESTsource - DimEligible + numESTsource + 1, -1
C        do InEST = 1, dimeligible - numESTsource

C         Let xTMP2 hold mass of linear combination
C         xTMP2 = 0.
          If ( work(InEST) .le. xTMP1 ) Then		!Branch terminates @2064

C           Check for negative solution;
C           if found, negate coefficients and linear combination:

            xTMP2 = 0.
            do n = 1, numInESTsource
              xTMP2 = xTMP2 +
     &            workixi( n, InEST ) * Sfit( indexInEST( n ) )
            enddo

            sign = 1.
            if ( xTMP2 .lt. 0. ) then
              sign = -1.
            endif

            numtoks = 4
            lentok = 15
            xTMP1 =  real( nPR - 1 ) / numtoks
            nRows = ifix( xTMP1 ) + 1
            do nOut = 1, nRows
              icol = 1
              writeflag = 0
              cLine = ' '
              do nInner = 1, numtoks
                n = numtoks * ( nOut - 1 ) + nInner

                if ( n .gt. numInESTsource ) then
                  goto 3200
                endif

                jPR = jPRfit( indexInEST( n ) )
                write( cLine(icol:icol+lentok-1),
     &            '( f6.4, 1x, a6, 2x )' )
     &            sign * workixi( n, InEST ), PRcode(jPR)(1:6)
                icol = icol + lentok
                writeflag = 1

              enddo

              write( format3a(5:5), '(i1)' ) displayDecPl
              write( cLine( 61: 69 ), format3a ) sign * xTMP2
              write( cLine( 70: 71 ), '(''+-'')' )
              write( cLine( 72: 80 ), format3a ) work( InEST )
              call Write2OutBuf( 1, outbuf, dimoutbuf, cLine,lenoutbuf )
              writeflag = 0

            enddo

3200        continue

            if ( writeflag .eq. 1 ) then
              write( cLine( 61: 69 ), format3a ) sign * xTMP2
              write( cLine( 70: 71 ), '(''+-'')' )
              write( cLine( 72: 80 ), format3a ) work( InEST )
              call Write2OutBuf( 1, outbuf, dimoutbuf, cLine,lenoutbuf )
            endif
          EndIf

        enddo

        WRITE(cLine,'( 80(1H=) )')
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      ENDIF

cx      GOTO 7099
C     Species concentrations output:
cx	NB:  The next series of lines to TO HERE are unnecessary as we don't repeat 
cx	the header in the Main Report.  Before they can be removed, however, a 
cx	conforming change must be made in the Delphi code.
      cLine = ' ' ! Skip a line below =========== before SPECIES CONCENTRATIONS:
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
cx      WRITE(cLine,4000)  siteID, DATE, VERNUM
      WRITE(cLine,4001)
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
cx4000  FORMAT('SPECIES CONCENTRATIONS - '
cx     &  ,' SITE: ',A12,' DATE: ',A8,1X,'      CMB ',A3)
4001  FORMAT('REDUNDANT HEADER starts here ...') ! This string to Delphi is a flag
C
      GOTO 7099 ! Skip the rest of this redundant header ...
      WRITE(cLine,
     &  '(''SAMPLE DURATION'',a10,6X,''START HOUR'',
     &  a10,8X,''SIZE: '',A8 )' )
     &    duration, START, sizeTMP
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,
     &  '(7X,''R SQUARE'',F10.2,4X,''PERCENT MASS'',F10.1 )' )
     &  Rsquare, pcntMass
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,
     &  '(5x,''CHI SQUARE'',F10.2,14x,''DF'',I10)' )
     &  CHIsqr, DegFree
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

C	TO HERE (see above)
7099  CONTINUE

      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,7100)
7100  FORMAT(
     &  'SPECIES-------I---','MEAS',18('-'),'CALC',13('-')
     &  ,'RATIO C/M',4('-'),'RATIO R/U')
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
	iLine = 6
C
      DO 7200 I=1,nSPtot
C
        RES = work(ncHat+i) - work(nambSP+i)
        SIGRES =
     &  SQRT( work(nucHat+i)*work(nucHat+i) +
     &        work(nuambSP+i)*work(nuambSP+i) )
        RESSIG = -99.

        IF( SIGRES .GT. 0.) RESSIG = RES/SIGRES ! Check for ERROR_CMBSVD_1 disabled 11/21/04 -TC;
	                                          ! it's caught in MainFrm.pas' func VerifyCMBRunInputsValid; TC 11/19/04
          IF( work(nambSP+i).LE.0.) THEN
            RATIO=0.
            URATIO=0.
          else
            RATIO=work(ncHat+i)/work(nambSP+i)
            URATIO =
     &        sqrt(
     &        ( work(nucHat+i)/work(nambSP+i)                     )**2
     & +      ( work(nuambSP+i)*work(ncHat+i)/(work(nambSP+i)**2) )**2
     &        )
          endif
C
          IF(work(nambSP+i).GE.work(nuambSP+i)) then
            write( format2( 26:27 ), '(a2)' ) '+-'
            write( format2( 44:45 ), '(a2)' ) '+-'
            write( format2( 62:63 ), '(a2)' ) '+-'
          else
            write( format2( 26:27 ), '(a2)' ) '< '
            write( format2( 44:45 ), '(a2)' ) '< '
            write( format2( 62:63 ), '(a2)' ) '< '
          endif

          write( format2( 23:23 ), '(i1)' ) displayDecPl
          write( format2( 33:33 ), '(i1)' ) displayDecPl
          write( format2( 41:41 ), '(i1)' ) displayDecPl
          write( format2( 51:51 ), '(i1)' ) displayDecPl

          WRITE(CHAR79, format2) SPcode(i)(1:6), SPcode(i)(8:15),
     &      SPcode(i)(15+2*sizeNDX:15+2*sizeNDX),
     &      work(nambSP+i),
     &      work(nuambSP+i),work(ncHat+i),work(nucHat+i),Ratio,URatio,
     &      RESSIG
C
          iLine=iLine+1

          WRITE(cLine,'(A79)') CHAR79
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
7200    CONTINUE
C
C        if( unit .eq. outfunit) WRITE(unit,'(1X,79(''-''))')
cx      write( cLine,'(1X,79(''-''))' ) CORRECTED to line below; TC 11/17/03
	write( cLine,'(80(''-''))' )          !Bottom (dashed) line of Main Report
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C-------------------------------------------------------------------------------
C     Check if TOTAL output is needed;
C     if so run through output block (@100 continue) one more time:
C
      IF (dichotFlag .eq. 2) then ! dichotFlag is passed from Delphi per run; 2=Dichot/1=NOT dichot.
        If ( sizeTMP .eq. 'COARSE' ) then
C         Check fitting species and sources to confirm dichotomous; this check is not made in Delphi's QC_Dichotomous.
          Dichot = .TRUE. ! We assume we have matched dichot. sample pair
C:::::::::Species:
          iTMP = 0
          do i = 1, nSPtot ! Scan the 1st part of iWork and look for tagged (=1) items (SPecies)
            if ( iWork(i) .eq. 1 ) then
              iTMP = iTMP + 1
            endif
          enddo
C
          if ( iTMP .ne. nSPfit ) then ! Check that # tagged SPecies match the fit count (nSPfit)
            Dichot = .FALSE.
          else
C
            do i = 1, nSPfit
              iWork( iSPfit(i) ) = 0 ! Reset "tagged" iWork array elements (SPecies) back to zeros
            enddo
C
            do i = 1, nSPtot ! reScan the 1st part of iWork and look for any tagged (=1) items (SPecies) 
              if ( iWork(i) .eq. 1 ) then
                Dichot = .FALSE.
              endif
            enddo
          endif

C:::::::::Sources:
          iTMP = 0
          do j = 1, nPRtot ! Scan the 2nd part of iWork and look for tagged (=1) items (PRofiles)
            if ( iWork(nSPtot+j) .eq. 1 ) then ! start with the next item after nSPtot; NB: in DRI's CMB8.0, index was (nSPtot+i)
              iTMP = iTMP + 1
            endif
          enddo
C
          if ( iTMP .ne. nPRfit ) then ! Check that # tagged PRofiles match the fit count (nPRfit)
            Dichot = .FALSE.
          else
            do j = 1, nPRfit
              iWork( nSPtot+jPRfit(j) ) = 0 ! Reset "tagged" iWork array elements (PRofiles) back to zeros
            enddo
C
            do j = 1, nPRtot ! reScan the 2nd part of iWork and look for any tagged (=1) items (PRofiles)
              if ( iWork(nSPtot+j) .eq. 1 ) then
                Dichot = .FALSE.
              endif
            enddo
          endif
          if (.NOT. Dichot) then
cx           DO SOMETHING?
          else ! Dichot is confirmed.
            ambFmass   =  ambFmassL  ! load "Last" value for Fine measured mass {was work(1)}
            UambFmass  =  UambFmassL ! load "Last" value for Fine measured unc {was work(nSPtot+1)}
            dichotCoarse = 1
          endif
        ElseIf ( sizeTMP .eq. 'FINE' ) then
C         Check fitting species and sources; this check is not made in Delphi's QC_Dichotomous.
          Dichot = .TRUE. ! We assume we have matched dichot. sample pair
C:::::::::Species:
          iTMP = 0
          do i = 1, nSPtot ! Scan the 1st part of iWork and look for tagged (=1) items (SPecies)
            if ( iWork(i) .eq. 1 ) then
              iTMP = iTMP + 1
            endif
          enddo
C
          if ( iTMP .ne. nSPfit ) then ! Check that # tagged SPecies match the fit count (nSPfit)
            Dichot = .FALSE.
          else
C
            do i = 1, nSPfit
              iWork( iSPfit(i) ) = 0 ! Reset "tagged" iWork array elements (SPecies) back to zeros
            enddo
C
            do i = 1, nSPtot ! reScan the 1st part of iWork and look for any tagged (=1) items (SPecies) 
              if ( iWork(i) .eq. 1 ) then
                Dichot = .FALSE.
              endif
            enddo
          endif

C:::::::::Sources:
          iTMP = 0
          do j = 1, nPRtot ! Scan the 2nd part of iWork and look for tagged (=1) elements (PRofiles)
            if ( iWork(nSPtot+j) .eq. 1 ) then ! start with the next item after nSPtot; NB: in DRI's CMB8.0, index was (nSPtot+i)
              iTMP = iTMP + 1
            endif
          enddo
C
          if ( iTMP .ne. nPRfit ) then ! Check that # tagged PRofiles match the fit count (nPRfit)
            Dichot = .FALSE.
          else
            do j = 1, nPRfit
              iWork( nSPtot+jPRfit(j) ) = 0 ! Reset "tagged" iWork array elements (PRofiles) back to zeros
            enddo
C
            do j = 1, nPRtot ! reScan the 2nd part of iWork and look for any tagged (=1) items (PRofiles)
              if ( iWork(nSPtot+j) .eq. 1 ) then
                Dichot = .FALSE.
              endif
            enddo
          endif
          if (.NOT. Dichot) then
cx          DO SOMETHING?
          else ! Dichot is confirmed.
            ambCmass   = ambCmassL  ! load "Last" value for Coarse measured mass {was work(1)}
            UambCmass  = UambCmassL ! load "Last" value for Coarse measured mass {was work(nSPtot+1)}
            dichotFine = 1
          endif
        Endif
      ENDIF
C-------------------------------------------------------------------------------
      cLine = ' '
      nLine = nLine + 1
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      nLine = nLine + 1
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C

      if (( dichotCoarse .eq. 1).AND.(dichotFine .eq. 1 )) TOTALflag = 1
      if ( TOTALflag .eq. 1 ) then
        sizeTMP = 'TOTAL' ! This is the ONLY place sizeTMP is set to TOTAL (tc)
        dichotCoarse = 0
        dichotFine   = 0
        TOTALflag    = 2  ! only to prevent re-execution of this if/then block
        GO TO 100 ! Now that sizeTMP = TOTAL, we will compute an SCE sum for the SameFit pair
      endif

      call Write2OutBuf( 2, outbuf, dimoutbuf, cLine, lenoutbuf )

      close( SumDirUn )
      return

C *** DEallocate workspace:
      DEALLOCATE( YWORK )

      END

C***********************************************************************
      SUBROUTINE SScont	 ! 18 arguments
     & (
     & nSPfitPR, nPRfitPR, jPRfit,
     & Sfit,
     & SPcode,   PROcode, nSPtotPR, Atot,
     & PRcode,  nPRtotPR,     work,   nworkPR,
     & ambSP,     uambSP,
     & outbuf, dimoutbuf, lenoutbuf, cLine
     & )

C	SScont is called by fRun.
C	Computes Species Contributions that appear in Main Report.

      integer*4
     & nSPfitPR, nPRfitPR, jPRfit(nPRfitPR),
     & nSPtotPR, nPRtotPR,  nworkPR,
     & dimoutbuf, lenoutbuf
C
      character*24 SPcode (nSPtotPR)
      character*24 PRcode (nPRtotPR)
      character*26 PROcode (*)
      character*(*) outbuf(dimoutbuf)
      character*(*) cLine
C
      real*4
     &   Sfit(nSPfitPR),       Atot(nSPtotPR, 1),
     &   work(nworkPR),
     &   ambSP(nSPtotPR),      uambSP(nSPtotPR)
C
      integer*4 ProRec
C
      include 'CMB82.inc'
C
C
C     local variables
C
      character*12 siteID1
      character*8  date1
      character*2  duration1, start1
      character*6  size1
C
      integer i, j, jRec, nPR, error1
C
C     Initialize output buffer
C
      call Write2OutBuf( 0, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      nPR = nPRfit
C
C     load ambSP and uambSP, ambient data arrays
C
      call AmbData( AMBdirect, siteID1, date1, duration1, start1,
     &              size1, ambSP, uambSP, error1)
C
      write( cLine, 100 ) siteID1
100   format( 'SOURCE CONTRIBUTIONS (     ) FOR SITE: ', a12 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, 200 ) date1, duration1, start1, size1
200   format(
     &  'DATE: ', a8,
     &  '  DURATION: ', a2, ',  START HOUR: ', a2,
     &  ',  SIZE: ', a6 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE( cLine, '( 30x, 24hCALC SPECIES(PER SOURCE) )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, '( 10X, 19hINDIVIDUAL RATIO = , 26(1h-) )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, '( 30X, 25hMEAS SPECIES(ALL SOURCES) )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, '( 1h )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, '( 35X, 11hSOURCE NAME )' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      WRITE(cLine, 19250) (PRcode(jPRfit(j))(8:13),J = 1,nPR)
19250 FORMAT( 'SPECIES', 999(1x,a6) )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
      DO 19400 I = 1,nSPtot
         DO 94600 J = 1,nPR
           TMP = -9.999
           jRec = ProRec ( PRcode( jPRfit(j) ), g_size, PROcode )
C	TMP stores ratios appearing in Contribution by Species matrix:
           IF(ambSP(i) .NE. 0.) TMP = Atot(i, jRec )*Sfit(J)/ambSP(i)
           WORK(J) = TMP
94600    CONTINUE
C
C xxx The following WRITE produces the Contributions-by-Species matrix that's 
C     shown in the Main Report.  Note that SPcode is a 24-byte field; 1:6 indexes 
C     the 1st part of the code name that ends in C.  The column 'CALCULATED' in the 
C     report is created somewhere else - perhaps in the Delphi.
C
        WRITE(cLine,19500) SPcode(I)(1:6)
     +  ,(WORK(J),J=1,nPR)
19500   FORMAT( 1X, a6, 999(1X,F6.3) )
        call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

19400 CONTINUE
C
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      call Write2OutBuf( 2, outbuf, dimoutbuf, cLine, lenoutbuf )

      return
      end

C***********************************************************************
        SUBROUTINE PIN ! 11 arguments
     &   ( iSPfit, nSPfitPR, jPRfit, SPcode, PRcode, mPINarr,
     &   work,         !scratch storage for call to AmbData
     &   outbuf, dimoutbuf, lenoutbuf, cLine )

C	PIN is called by fRun.

      character*24 SPcode (*)
      character*24 PRcode (*)
C
      integer*4 dimoutbuf, lenoutbuf

      integer nSPfitPR
      integer*4 iSPfit(nSPfitPR), jPRfit(nSPfitPR)
      real*4 work(*)

      character*(*) outbuf(dimoutbuf)

C     This is passed because its size is variable:
      character*(*) cLine

      real*4 mPINarr( nSPfitPR, 1 )
C
      include 'CMB82.inc'
C
C     Local variables:
C
      integer*4 j, i
C
      character*12 siteID1
      character*8  date1
      character*2  duration1, start1
      character*6  size1
      integer*4    error1
C
      call AmbData( AMBdirect, siteID1, date1, duration1, start1,
     & size1, work, work, error1)
C
C     Initialize output buffer
C
      call Write2OutBuf( 0, outbuf, dimoutbuf, cLine, lenoutbuf )
C

      write( cLine, 100 ) siteID1
100   format( 'TRANSPOSE OF SENSITIVITY MATRIX FOR SITE: ', a12 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, 200 ) date1, duration1, start1, size1
200   format(
     &  'DATE: ', a8,
     &  '  DURATION: ', a2, ',  START HOUR: ', a2,
     &  ',  SIZE: ', a6 )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      write( cLine, '(35X, 11hSOURCE NAME)' )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      WRITE(cLine,19250) (PRcode(jPRfit(j))(8:13),J = 1,nPRfit)
19250 FORMAT( '   SPECIES', 999(1x,a6) )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

C
      DO 2000 I = 1, nSPfitPR
C
C xxx The following write produces the mPIN matrix that's shown in the Main Report.
C     Note that SPcode is a 24-byte field; 1:6 indexes the 1st part of the code name 
C     that ends in C.
C
       WRITE(cLine,2300) SPcode( iSPfit(i) )(1:6),
     +   (mPINarr(i,j),j = 1, nPRfit)
2300   FORMAT( 4x, a6, 999(1X,F6.2) )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
C
C
2000  CONTINUE
C
      cLine = ' '
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )
      call Write2OutBuf( 1, outbuf, dimoutbuf, cLine, lenoutbuf )

      call Write2OutBuf( 2, outbuf, dimoutbuf, cLine, lenoutbuf )
C
        return
        end