C     These supplemental routines support those in CMB82a.for, and each other
C     (see respective documentation for sources of these calls).  They are listed 
C     in alphabetical order:

C***********************************************************************
      subroutine AmbData( ambrc, siteID1, date1, duration1,
     &                    start1, size1, x, ux, error1 )

C     AmbData is called by s.FitAlloc, s.PData, s.SScont & s.PIN.
cx    It reads AmbDirUn once opened by OpenAmbDir.

      character*12 siteID1
      character*8 date1
      character*2 duration1, start1
      character*6 size1
C
      integer*4 ambrc, error1
      real*4 x(*), ux(*)
C
      include 'CMB82.inc'
C
      integer i
C
      call OpenAmbDir
C
        error1 = 0
        read ( AmbDirUn, rec = ambrc, err = 9000)
     &  siteID1, date1, duration1, start1, size1,
     &  (x(i), ux(i), i = 1, nSPtot)

        close( AmbDirUn )
        return
C
9000    continue
        error1 = ERROR_FILE_READ
        close( AmbDirUn )
        return
        end

C***********************************************************************
      subroutine GetAMBdirect( ADcode, AmbRec1, AMBDirect1 )

C     GetAmbRec is called by s.PData.

      character*42 ADcode(*)
      integer*4 AmbRec1, AMBdirect1
C
      include 'CMB82.inc'
C
      call SUBATOL( ADcode(AmbRec1)(37:42), 6, AMBdirect1 )
C
      return
      end

C***********************************************************************
C     Initialize
C
C     Initialize is called by CMB82.c
C     Declares variables & dimensions arrays.

      integer*4 function Initialize(
     &  nSPtot1, 
     &  nPRtot1, 
     &  nambtot1, 
     &  nPROtot1, PROcode,
     &  NumSizes1, SizNames1,
     &  ambname1, AmbDirName1,
     &  proname1, ProDirName1, SumDirName1,
     &  atotal, uatotal, 
     &  idummy )

      integer*4 nSPtot1, nPRtot1, nambtot1, nPROtot1
      integer*4 NumSizes1
      character*(26) PROcode( nPROtot1 )
      character*(6) SizNames1( NumSizes1 )
      character*(*) ambname1, proname1, AmbDirName1, ProDirName1,
     &  SumDirName1
      real*4 atotal( nSPtot1, nPROtot1 )
      real*4 uatotal( nSPtot1, nPROtot1 )

      integer*4 idummy

C     Common Block initialization
      include 'CMB82.inc'

C     local variables
      integer*4 n

      nSPtot   = nSPtot1
      nPRtot   = nPRtot1
      NumSizes = NumSizes1

      do n = 1, NumSizes
        SizNames(n) = SizNames1(n)
      enddo

C     number of ambient data records	  
      NumAmbRec = nambtot1

C     number of source profile records (ALL size ranges)
      NumProRec = nPROtot1
C
      numcmbfit = idummy  !Initialize

      vernum = '8.2'
      rvsdat = '08/30/04'
C
c     Fortran disk file access unit numbers
c
      ProDirUn = 20            ! PROdirect.dat
      AmbDirUn = 21			 ! AMBdirect.dat
      SumDirUn = 22			 ! SumDirect.dat

      AMBname = AMBname1
      PROname = PROname1

      AmbDirName = AmbDirName1 ! AMBdirect.dat
      ProDirName = ProDirName1 ! PROdirect.dat
      SumDirName = SumDirName1 ! SumDirect.dat

      nSPtot = nSPtot1		 ! Total number of species

      Afitbase = 1
      nSPfit   = 1
      nPRfit   = 1
C
C     Load atot and uatot
C
      call LoadATOT ( atotal, uatotal, NumProRec, nSPtot,
     &   nPROtot1, PROcode )
C
      miss = -99.
      Initialize =  0

      return
      end

C***********************************************************************
      subroutine LoadATOT ( atot, uatot, nprorc, netot,
     &                      nPROtot1, PROcode )

C     LoadATOT is called by f.Initialize.

      integer nprorc, netot, nPROtot1
      real*4 atot(netot, nprorc), uatot(netot, nprorc)
      character*26 PROcode(nPROtot1)

      include 'CMB82.inc'
C
C     local variables
C
        integer*4  i, n, nrec
C
        character*6 num
	  character*6 siz
        character*8 name

      call OpenProDir

        do 1000 n = 1, nprorc

        read ( PROcode(n)(21:26), '(i6)') nrec ! PROcode is a nPROrc-dimension 
	                                         ! array of "pedigree" info 
	                                         ! on the source PRofiles (4 fields):
	                                         ! PRofile code/#; PRofile name; size fraction; record index (which maps to the record number in ProDir.dat).

        read ( ProDirUn, rec = nrec )  
     +         num, name, siz, (atot(i,n), uatot(i,n), i= 1,netot)
C
1000    continue
C
        close( ProDirUn )

        return
        end

C***********************************************************************
      subroutine MATMUL( a, m, k, la, b, n, lb, p, lp )
C     MATMUL is called by s.CMBSVD and returns the matrix product of a and b
C     a => m x k matrix
C     la => leading dimension of a as defined in calling program
C     b => k x n
C     lb => leading dimension of b as defined in calling program
C     p => output matrix
C     lp => leading dimension of p as defined in calling program

      integer n, k, la, m, lb, lp
      real*4 a(la,*), b(lb,*), p(lp,*)
C
C     local variables
C
      integer i, j, kk
      real sum

      do i = 1, m
        do j = 1, n
          sum = 0.
          do kk = 1, k
            sum = sum + a(i,kk) * b(kk,j)
          enddo
          p(i,j) = sum
        enddo
      enddo

      return
      end

C***********************************************************************
      subroutine MATSIN ( A, Norder, iA, Ainv, iAinv, iER )

C     MATSIN is called by s.CMBSVD.
C     iER is returned as 'INFO'; 0 = successful exit

      integer Norder, iA, iAinv, iER
      REAL A(iA,1), Ainv(iAinv,1)

      INTEGER, ALLOCATABLE :: IWORK(:)
      REAL, ALLOCATABLE    :: YWORK(:)

      include 'CMB82.inc'

C     local variables
C
      integer*4 i, j
C
      DO 1000 I = 1,NORDER
      DO 1000 J = 1,NORDER
      Ainv(I,J) = A(I,J)
1000  CONTINUE

C *** Allocate workspace before calls to LAPACK:
      IF( Norder.GT.0 ) THEN
          ALLOCATE( IWORK(Norder) )
          ALLOCATE( YWORK(3*Norder) )
      END IF

C *** LINPACK's SPOCO (which calls SPOFA) & SPODI are replaced by LAPACK's SPOTRF 
C     & SPOTRI:
C     SPOTRF computes the Cholesky factorization of a real, positive definite 
C	matrix A (here, Ainv).  The factorization has the form A = U**H * U, where 
C	U is an upper triangular matrix.
C     SPOTRI computes the inverse of the matrix A computed by SPOTRF.

C     UPLO = 'U' => Upper triangle of coefficient matrix A is stored
C     UPLO = 'U' => Upper triangle of coefficient matrix A is stored

      CALL SPOTRF( 'U', Norder, Ainv, iAinv, iER )
        IF( iER .NE. 0 ) RETURN
      CALL SPOTRI( 'U', Norder, Ainv, iAinv, iER )

      DO 2000 I = 1, Norder
      DO 2000 J = 1, I
         Ainv(I,J) = Ainv(J,I)
2000  CONTINUE

C *** DEallocate workspace after calls:
      IF( Norder.GT.0 ) THEN
         DEALLOCATE( IWORK )
         DEALLOCATE( YWORK )
      END IF

      RETURN
      END

C***********************************************************************
      subroutine OpenAmbDir

C     OpenAmbDir is called by s.AmbData & f.SetAmbRec.
C     Opens ambient data file and specifies record lengths via RECL stmt.

      include 'CMB82.inc'

C       ambient data
C
C       site id   12
C       date       8
C       duration   2
C       start hour 2
C       size       6
C       total   = 30
CX      AmbDirName = AMBdirect.dat (Unit 21):

        open (AmbDirUn, file = AmbDirName, access = 'direct',
     +  recl = 30 + 8*nSPtot)

        return
        end

C***********************************************************************
      subroutine OpenProDir

C     OpenProDir is called by s.LoadATOT.
C     Opens source profile data file and specifies record length via RECL stmt.

      include 'CMB82.inc'

C     profile # 6
C     name      8
C     size      6
C     total  = 20
CX    ProDirName = PROdirect.dat (Unit 20):

      open (ProDirUn, file = ProDirName, access = 'direct',
     +  recl = 20 + 8*nSPtot)
C
      return
      end

C***********************************************************************
      subroutine OpenSumDir

C     OpenSumDir is called by s.CMBSVD, s.PData, s.SFitOut.
C     Opens summary data file and specifies record lengths via RECL stmt.

      include 'CMB82.inc'
C
C     open summary data file
C
C     number of bytes
C
C     AMBdirect - 4
C     iSPfit    - 4 * nSPtot
C     jPRfit    - 4 * nPRtot
C     Sfit      - 4 * nPRtot
C     uSfit     - 4 * nPRtot
C     cHat      - 4 * nSPtot
C     ucHat     - 4 * nSPtot
C
CX    SumDirName = SumDirect.dat (Unit 22):

      open(SumDirUn, file = SumDirName, access = 'direct',
     +  recl = 4 * ( 3 * nPRtot + 3 * nSPtot + 1 ) )

      return
      end

C***********************************************************************
      integer*4 function ProRec ( PRcode, siz, PROcode )

C     ProRec is called by s.CMBSVD, s.SFitOut, s.SScont, s.SETiWORK.

      character*6 PRcode, siz
      character*26 PROcode(*)
C
      include 'CMB82.inc'
C
C     local variabels
C
      integer*4 n
C
      ProRec = -1
      do 1000 n = 1, NumProRec
C
        if ( PROcode(n)(15:20) .eq. siz ) then
           if ( PROcode(n)(1:6) .eq. PRcode ) then
             read ( PROcode(n)(23:26), '(i4)' ) ProRec ! 10/2004 - TC changed from (22:25) to
		                                             ! accomodate widening of Size Fraction field to 6 chars
             return
           endif
        endif
C
1000  continue
C
      return
      end

C***********************************************************************
      integer*4 function SetAmbRec( ADcode )

C     SetAmbRec is called by CMB82.c

      character*42 ADcode(*)
      include 'CMB82.inc'

      character*12 siteID1
      character *8 date1
      character *2 duration1, start1
      character *6 size1
C
C     local variables
C
      integer*4 i, j
C
      call OpenAmbDir

C     Set AMBdirect
C *** Loop thru here 'till you find a tagged sample (TC).
C     AmbRec is critical for driving multiple batch runs; 
C     it should recycle from 1 -> NumAmbRec each time.

      do 2000 j = 1, NumAmbRec
C

        AmbRec = 0
C
        if ( ADcode(j)(36:36) .eq. '*' ) then
          AmbRec = j
          call SUBATOL
     &    ( ADcode(j)(37:42), 6, AMBdirect )
C
C     Set sizeNDX
C
          sizeNDX = 0
C
          if( AmbRec .gt. 0 ) then
            read ( AmbDirUn, rec = AMBdirect ) ! Read only the 1st 5 fields; there's more ...
     &        siteID1, date1, duration1,
     &        start1, size1
            do 2200 i = 1, NumSizes
            if (size1 .eq. SizNames(i) ) sizeNDX = i
2200        continue
          endif
C
          go to 2100
        endif
C
2000  continue
C
2100  continue
C
      SetAmbRec = 256 * AmbRec + sizeNDX

      close( AmbDirUn )
      return
      end

C***********************************************************************
      subroutine SETiWORK ( SPcode, SPcode_user, PRcode, PRcode_user,
     &                      iSPfit, jPRfit, atotal, ambSP, nSPtotPR, 
     &			          nPRtotpr, PROcode, error1 ) ! TC added error 1 to handle ProRec (-1) error

C	SETiWORK is called by s.FitAlloc & s.ChecksFit.

        integer*4 nSPtotPR, nPRtotpr
        character*24 PRcode(*)
        character*26 PROcode(*)
        character*24 PRcode_user(*)
        character*24 SPcode(*)
        character*24 SPcode_user(*)
        integer*4 iSPfit(*)
        integer*4 jPRfit(*)
        real*4 ambSP(*), atotal( nSPtotPR, * )
        integer*4 jrec, ProRec, error1
C
        include 'CMB82.inc'
C
C       local variables
        integer*4 i, j, jflag,  n

C
C     load default values into SPcode
C
      do i = 1, nSPtotPR
        SPcode(i) = SPcode_user(i)
      enddo
C
C     load default values into PRcode
C
      do j = 1, nPRtotpr
        PRcode(j) = PRcode_user(j)
      enddo
C
C     check source profiles and ambient data for missing values
C     and eliminate from fit

C
      jflag = 15 + 2*sizeNDX
      do i = 1, nSPtotPR
C
        if ( abs( ambSP(i) - miss ) .lt. 1.e-5 ) then
          if ( SPcode(i)(jflag:jflag) .eq. '*' ) then
            SPcode(i)(jflag:jflag) = 'M'
          endif
        endif

C
        do j = 1, nPRtot
          if ( PRcode(j)(jFlag:jFlag) .eq. '*' ) then
            jRec = ProRec ( PRcode(j), g_size, PROcode )

CX          TC added 11/06/04:
	      if ( jRec .eq. -1 ) then ! ProRec was not properly set
              write (message, 100) jRec, newline(2:2), newline(2:2)
100           format('This message is from sub.SETiWORK, where ProRec wa
     &s improperly set to: ', I2, A1
     &'A likely cause was that the Size Fraction name in the PRofile dat
     &a input file [PR*.*]', A1,
     &'is mismatched with that in other input files.  Result for that si
     &ze fraction will be excluded.')

              call WinMessage
              error1 = ERROR_READ_PROFILE
C     EXIT *****************************
              return
            elseif (abs( aTotal(i,jRec) - miss ) .lt. 1.e-5 )  then
                if ( SPcode(i)(jFlag:jFlag) .eq. '*' ) then
                  SPcode(i)(jFlag:jFlag) = 'M'
                endif
            endif ! jRec = -1 or else
          endif
        enddo
C
      enddo
C
C       Set iSPfit
C

        n = 0
        do i = 1, nSPtot
C
          if ( SPcode(i)(jflag:jflag) .eq. '*' ) then
            n = n + 1
            iSPfit(n) = i
          endif
C
        enddo
C
        nSPfit = n
C
C       set jPRfit
C
        n = 0
        do j = 1, nPRtot
C
          if ( PRcode(j)(jflag:jflag) .eq. '*' ) then
            n = n + 1
            jPRfit(n) = j
          endif
C
        enddo
C
        nPRfit = n
C
        iworkbase = 1
C
        return
        end

C***********************************************************************
      subroutine SETWORK

C	SETWORK is called by s.FitAlloc & s.ChecksFit.

        include 'CMB82.inc'
C
C       local variables
C
        integer l, nSP, nPR
C
        nSP = nSPfit
        nPR = nPRfit

        l = Afitbase + nSPfit*nPRfit
        uAfitbase = l
        l = l + nSPfit*nPRfit
        cHatbase = l
        l = l + nSPtot
        ucHat base = l
        l = l + nSPtot
        Sfitbase = l
        l = l + nPRfit
        uSfitbase = l
        l = l + nPRfit
        sngvalbase = l
        l = l + nPRfit
        edummybase = l
        l = l + nPRfit
        egnvecbase = l
        l = l + nPRfit*nPRfit
        Uarraybase = l
        l = l + nSPfit*nSPfit
C       additional storage for CMBSVD's B&L solution
        workixibase = l
        l = l + nSPfit*nSPfit
        workix1base = l
        l = l + nSPfit
        veffinvbase = l
        l = l + nSPfit
C       additional storage for MPIN
        mPINbase = l
        l = l + nSPfit * nSPfit
C       additional storage for inestimable sources
        sinestimbase = l
        l = l + nPRfit * nPRfit

        workbase = l
C
        return
        end

C***********************************************************************
      subroutine SFitHead ( action, type, PRcode, SFitBuf )

C     SFitHead is called by CMB82.c
C     Creates header for the source fit display.

      integer*4 action, type
      character*24 PRcode(*)
      character*(*) SFitBuf

      include 'CMB82.inc'
C
      integer*4 j
      character*24 cbuf

      if ( action .eq. 1 ) then

        if ( type .eq. 1 ) then 

          write(SFitBuf, 3200) ! Generate header for ASCII format:
     &      ( PRcode( (j) )(1:6), PRcode( (j) )(7:14), j = 1, nPRtot )

3200        format
     &      ('SPcode SPname   I SiteID       DATE     ST DR SIZE     ',
     &       'Mconc      Munc     Cconc      Cunc     Rsquare   CHIsqr  
     &   %MASS    ', 999(a6, 4x, a8, 2x) )

        else if ( type .eq. 2 ) then

          write(SFitBuf, 3210) ! Generate header for CSV format:
     &      ( PRcode( (j) )(1:6), PRcode( (j) )(7:14), j = 1, nPRtot )
3210        format
     &      ( 'SPcode,SPname,Fit,SiteID,DATE,          ST,         DR,',
     &        'SIZE,Mconc,Munc,Cconc,Cunc,Rsquare,'
     &        'CHIsquare,%MASS',
     &        999( 1h,,a6, 1h,,a8 )
     & )
        endif

        return
      endif
C
      if ( action .eq. 2 ) then
        cbuf = 'N           N           '
          write(SFitBuf, 3300) ( cbuf, j = 1, nPRtot )
3300      format
     &    ('C      C        C C            C        C  C  C     ',
     &     'N   ', 8X, 'N    ', 7X, 'N     ', 6X, 'N       ', 4X,
     &     'N     ', 6X,
     &     999(a24) )
        return
      endif
C
      if ( action .eq. 3 ) then
        cbuf = '11          11          '
          write(SFitBuf, 3400) ( cbuf, j = 1, nPRtot )
3400      format
     &    ('6      8        1 12           8        2  2  5     ',
     &     '11  ', 8X, '11   ', 7X, '11    ', 6X, '11      ', 4X,
     &     '11    ', 6X,
     &     999(a24) )
C       return
      endif

      if ( action .eq. 4 ) then
        cbuf = '5           5           '
          write(SFitBuf, 3500) ( cbuf, j = 1, nPRtot )
3500      format
     &    ('0      0        0 0            0        0  0  0     ',
     &     '5   ', 8X, '5    ', 7X, '5     ', 6X, '5       ', 4X,
     &     '5     ', 6X,
     &     999(a24) )
C       return
      endif

      return
      end

C***********************************************************************
      subroutine SFitOut ( action, type, Sfit, uSfit, atot, uatot,
     &                     nSPtotPR, iwork, ambSP, uambSP, jPRfit,
     &                     SPcode, PRcode, PROcode, work, SFitBuf,
     &                     error1 )

C     SFitOut is called by CMB82.c

      integer*4 action, type, jPRfit(*), nSPtotPR, error1
      integer*4 iwork(*)
      real*4 Sfit(*), uSfit(*), ambSP(*), uambSP(*),
     &  atot(nSPtotPR, 1), uatot(nSPtotPR, 1), work(*)
      character*24 SPcode(*)
      character*24 PRcode(*)
      character*26 PROcode (*)
      character*(*) SFitBuf
C
      include 'CMB82.inc'
C
      integer*4 ProRec
C
      integer*4 i, j, jPR, jrec, arec
      character*1 flag

      character*83 format1
      character*70 format2
      character*45 format3

C     Position of decimal place in format specifier character strings
      integer format1pos, format2pos, format3pos

      save format1, format2, format3

      data format1 /
     & '(a6,1x,a8,1x,a1,1x,a12,1x,a8,1x,a2,1x,a2,1x,a6,999(1x,f9.5))'/

      data format2 /
     & '(a6,1h,,a8,1h,,a1,1h,,a12,1h,,a8,1h,,a2,1h,,a2,1h,,a6,999(1h,,f9
     &.5))'/

      data format3 /
     & '(1h ,a6,a8,a1,a12,a8,a2,a2,a6,999(f9.5))'/

      data format1pos, format2pos, format3pos
     &  / 58, 66, 38 /

      call OpenSumDir

      read( SumDirUn, rec = numCMBfit ) arec,
     &  ( iwork(i), i = 1, nSPtot+nPRtot),
     &  ( Sfit(j), j = 1, nPRtot ),
     &  ( uSfit(j), j = 1, nPRtot )

C
C       Load Sfit in work for all sources:
C
        do j = 1, nPRtot
          work(j) = miss
          work(nPRtot+j) = miss
        enddo
C
        do j = 1,nPRfit
          work(jPRfit(j)) = Sfit(j)
          work(nPRtot+jPRfit(j)) = uSfit(j)
        enddo

      if ( action .eq. 1 ) then
C
C       i = 1 - Total Mass
C
        flag = SPcode( (1) )(15+2*sizeNDX:15+2*sizeNDX)

CX      Do ASCII (.txt) format:
        if ( type .eq. 1 ) then

          write( format1( format1pos:format1pos ), '(i1)' )
     &      displaydecpl

          write(SFitBuf, format1, iostat = error1 )
     &    SPcode(1)(1:6), SPcode(1) (8:15), flag,
     &    siteID, date, start, duration, g_size,
     &    ambSP(1), UambSP(1), CalConc(1), CalcUnc(1), RSquare, CHIsqr, ! Total measured and calculated values for the sample
     &    pcntMass, ( Sfit(j), uSfit(j), j = 1, nPRtot )

CX      Do Comma-separated Value (.csv) format:
        else if ( type .eq. 2 ) then

          write( format2( format2pos:format2pos ), '(i1)' )
     &      DisplayDecPl

          write(SFitBuf, format2, iostat = error1 )
     &    SPcode( (1) )(1:6), SPcode(1) (8:15), flag,
     &    siteID, date, start, duration, g_size,
     &    ambSP(1), UambSP(1), CalConc(1), CalcUnc(1), RSquare, CHIsqr,  ! Total measured and calculated values for the sample
     &    pcntMass, ( Sfit(j), uSfit(j), j = 1, nPRtot )


CX      Do dBase (.dbf) & Worksheet (.wks) format:
        else if ( type .eq. 3 ) then

          write( format3( format3pos:format3pos ), '(i1)' )
     &      DisplayDecPl

          write(SFitBuf, format3, iostat = error1 )
     &    SPcode( (1) )(1:6), SPcode(1) (8:15), flag,
     &    siteID, date, start, duration, g_size,
     &    ambSP(1), uambSP(1), RSquare, CHIsqr, pcntMass,
     &    ( Sfit(j), uSfit(j), j = 1, nPRtot )

        endif
C
        close(SumDirUn)
	  return
      endif
C
      if ( action .ne. 1 ) then
        i = action
C
C       Load Sfit in work for all sources:
C
        do j = 1, nPRtot
          work(j) = miss
          work(nPRtot+j) = miss
        enddo
C
        do j = 1,nPRfit
          jPR = jPRfit(j)
          jrec = ProRec ( PRcode( jPR ), g_size, PROcode )
          work(jPRfit(j)) = atot( i, jrec )*Sfit( jPR )
          work( nPRtot+jPR ) = abs( uatot(i, jrec)*Sfit( jPR ) )
        enddo
C
        flag = SPcode( (i) )(15+2*sizeNDX:15+2*sizeNDX)
C
        if( flag .eq. ' ' ) flag = '_'

        if ( type .eq. 1 ) then

          write( format1( format1pos:format1pos ), '(i1)' ) ! Do ASCII format
     &      displaydecpl
          write(SFitBuf, format1, iostat = error1 )
     &      SPcode( (i) )(1:6), SPcode(i) (8:15), flag,
     &      siteID, date, start, duration, g_size,
     &      ambSP(i), UambSP(i), CalConc(i), CalcUnc(i), RSquare,CHIsqr,
     &      pcntMass, ( work(j), work(nPRtot+j), j = 1, nPRtot )

       else if ( type .eq. 2 ) then

          write( format2( format2pos:format2pos ), '(i1)' ) ! Do CSV format
     &      DisplayDecPl
          write(SFitBuf, format2, iostat = error1 )
     &      SPcode( (i) )(1:6), SPcode(i) (8:15), flag,
     &      siteID, date, start, duration, g_size,
     &      ambSP(i), UambSP(i), CalConc(i), CalcUnc(i), RSquare,CHIsqr,
     &      pcntMass, ( work(j), work(nPRtot+j), j = 1, nPRtot )

       else if ( type .eq. 3 ) then

          write( format3( format3pos:format3pos ), '(i1)' )
     &      DisplayDecPl
          write(SFitBuf, format3, iostat = error1 )
     &      SPcode( (i) )(1:6), SPcode(i) (8:15), flag,
     &      siteID, date, start, duration, g_size,
     &      ambSP(i), uambSP(i), RSquare, CHIsqr, pcntMass,
     &      ( work(j), work(nPRtot+j), j = 1, nPRtot )

       endif

        close(SumDirUn)
        return

      endif
c
      close(SumDirUn)

      return
      end

C***********************************************************************
      subroutine SUBATOL ( c, nc, ic )

C     SUBATOL is called by s.FitAlloc, s.GetAMBdirect & f.SetAmbRec.

        integer ic, nc
        character*(*) c
C
      read( c(1:nc), * ) ic
C        ic = k
        return
        end

C***********************************************************************
      subroutine WinMessage

C	WinMessage is called by s.CMBSVD & s.Write2OutBuf. 

      include 'CMB82.inc' ! TC added 11/22/04, to replace ref. to Cmessage.inc
      integer*4 n

      do n = 1, 254

        if ( message(n:n) .eq. char(0) ) then
          message(n:n) = ' '
        endif

      enddo

C	'MessageBoxC_( message )' is in CMB82.c
      call MessageBoxC_( message )
      return
      end

C***********************************************************************
      subroutine Write2ErrBuf( inputFlag, errbuf, dimerrbuf, line, 
     &                         lenerrbuf )

C     Write2ErrBuf is caled by s.CMBSVD.

      integer*4 inputFlag, dimerrbuf, lenerrbuf
      character*(*) errbuf( dimerrbuf )
      character*(*) line

C     local variables

      integer*4 linenum

      save linenum
C
      if( inputFlag .eq. 0 ) then
        linenum = 0

      else if (inputFlag .eq. 1 ) then
        linenum = linenum + 1

        if ( linenum .le. dimerrbuf ) then
          write( errbuf(linenum), '(a)' ) line(1:lenerrbuf)
        else
C ERROR MESSAGE
        endif
      else
C
        linenum = linenum + 1
        write( errbuf(linenum), '(a)' ) char(0)

      endif
      return
      end

C***********************************************************************
      subroutine Write2OutBuf( inputFlag, outbuf, dimoutbuf, line, 
     &                         lenoutbuf )

C     Write2OutBuf is called by s.PData, s.SScont & s.PIN.

      integer*4 inputFlag, dimoutbuf, lenoutbuf
      character*(*) outbuf( dimoutbuf )
      character*(*) line

      include 'CMB82.inc' ! TC added 11/22/04, to replace ref. to Cmessage.inc!

C     local variables
      integer*4 linenum, n
      save linenum
C
      if( inputFlag .eq. 0 ) then
        linenum = 0
C EXIT *************************
        goto 99999
      else
        linenum = linenum + 1
      endif

      if ( linenum .le. dimoutbuf ) then

        if ( inputFlag .eq. 1 ) then
          write( outbuf(linenum), '(a)' ) line(1:lenoutbuf)
        else

          write( outbuf(linenum)(1:1), '(a)' ) char(0)

        endif

      else
        write( outbuf(linenum-1)(1:1), '(a)' ) char(0)
        write( message,
     &   '( ''out of buffer in Write2OutBuf: line # = '', i5 )' )
     &    linenum
        call WinMessage
      endif

99999 continue
C
C     blank line

      do n = 1, lenoutbuf
        line(n:n) = ' '
      enddo

      return
      end

C***********************************************************************
      subroutine XLCunc ( nPRfit, xcoef, Sfit, egnvec, sngval, xLC, 
     &                    uxLC )

C     XLCunc is called by s.CMBSVD.
C     Computes uncertainties (SDTERR) for SCEs.

      integer nPRfit
C
      real*4
     &   xcoef(nPRfit),      Sfit(nPRfit),     egnvec(nPRfit,nPRfit),
     &   sngval(nPRfit), xLC, uxLC
C
      integer
     &   n,        i,        j,        k
C
      real*4
     &   xTMP1,    xTMP2,    xTMP3,    scomb,    scmvar
C
C *** Calculate the results of the Linear Combination (LC):
C
      n = nPRfit
      Scomb = 0.0
      SCMVAR = 0.0
      DO 1000 I = 1, n
      xTMP1 = xcoef(i)
        if (xTMP1 .ne. 0.) then
        Scomb = Scomb + xTMP1*Sfit(i)
        DO 2000 J=1,n
        xTMP2 = xcoef(j)
          if (xTMP2 .ne. 0.) then
          xTMP3 = 0.
          do 3000 k = 1,n
          xTMP3 = xTMP3 + egnvec(i,k)*egnvec(j,k)/sngval(k)/sngval(k)
3000      continue
          SCMVAR = scmvar + xTMP1*xTMP2*xTMP3
          endif
2000    CONTINUE
        endif
1000  CONTINUE
C
      xLC = Scomb
      uxLC = sqrt(scmvar)
      RETURN
      END

C***********************************************************************
      blockdata

      include 'CMB82.inc'

C     'newline' is used for formatting text in WinMessage
      integer*1 cr, lf
      equivalence ( cr, newline(1:1) )
      equivalence ( lf, newline(2:2) )

      data cr, lf / 13, 10 /              ! Apply ASCII character codes

      end